#include <Pilot.h> 
#include <SysEvtMgr.h> 
#include "AgentsRes.h" 
#include "NetForm.h"
#include "DebugWnd.h"
#include "CntXFer.h"

#ifdef WITH_MINSTREL
#include "Minstrel.h"
#endif
 
 
typedef struct 
{ Byte replaceme; } NetFormPreferenceType  ;

const unsigned long  NetFormFileCreator = 'NTFM';
 

static addFormActive; 

static char FormNameStash[80];

static Word appPrefID = 1;
static Word appPrefVersionNum = 1;

static int ClearForm ();
static void RequestForm ( char * FormName );
 
 /***********************************************************************
 *
 *   Internal Functions
 *
 ***********************************************************************/


static void UIBlink ( int Start , int End )
{
   static bMainFrmUpd;

      if ( bMainFrmUpd  )
      {
	 bMainFrmUpd = false;
	 WinDrawLine ( Start , 5 , End , 5 );
      } 
      else
      {
 	 bMainFrmUpd = true;
	 WinEraseLine ( Start , 5 , End , 5 );
      }
}


static VoidPtr GetObjectPtr(Word objectID)
{
  FormPtr frmP;


  frmP = FrmGetActiveForm();
  return (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID)));
}


/*********************************** INTERNAL FUNCTIONS *************************/


void NetDebug (char *One, char *Two);
void NetError (char *One, char *Two );

static CharPtr CityLst[] = {   
			      "Maryland" , "Washington" , "New York" , 
			      "Paris" , "Los Angeles" , "Orlando" , "Chicago" ,
		              "London", "San Francisco" , "San Jose" ,
			      "Don't care" } ; 
			     
			    

static CharPtr CuisLst[] = {  "Don't care" ,"American", "Mexican", "Steakhouses", "International", "Cajun", "Indian" ,
			      "Delis","French"};

static CharPtr PeopleLst[] = {  "2 People" , "4 People" ,  "6 People" };


char nFormBuffer[190];

void ProcessForm ()
{



}


static void CntMessageReceived ( i )
{

   CntMsgObj * msgObj =  &cntDta.Rcv[i];
   int c;
   int usrDone = 0;
   int m;
   int j = 0;
 
   int  fldNum = 0;
   int FormKind = 0;   /* F = main form , R = reply form */


   // PRINTF ( "CENTAURUS MESSAGE HAS BEEN RECEIVED " );
   // PRINTF ( "MESSAGE #### %d " , i );

   // PRINTF ( "Message Received\nObj %s \nTime %d \nSize %d",
            // msgObj->Id , msgObj->TimeStamp, msgObj->Size );
   i = 0;

   /* Find out what we got */
    c = CntMsgNextChar ( msgObj )  ;
    if ( CntMsgNextChar ( msgObj ) != '|'  ||
	 (c != 'F' && c != 'R')  ) 
		{
		    /* Poor signal quality */
		    RequestForm ( FormNameStash );
		    FrmGotoForm ( BadSignalForm );
		    ClearForm ();
	            return ;
		}	
	else FormKind = c;
  

    nForm[fldNum].Class = End;
   /* Collect data and process the fields */
     j = 0;
     while ( c = CntMsgNextChar ( msgObj ) )
        {
	   nFormBuffer[j] = c;
	   if ( j > sizeof(nFormBuffer)-5 ||  c == '\n' )
	   {
	      nFormBuffer[j] = 0;
	      ProcessField ( fldNum , nFormBuffer );
	      j = 0;
	      fldNum++;
	   } else j++;
        }
   
   /* Switch to the right kind of form */
   switch ( FormKind )
   {
    case 'F':
     FrmGotoForm ( MainForm );
     break;
    case 'R':
     FrmGotoForm ( ReplyForm );
     break;
   }
}

static void CheckForMail ()
{
        int i;
 	for ( i = 0 ; i < MAX_OBJECTS ; i ++ )
        if ( cntDta.Completed[i] != 0 ) 
 	{
            CntMessageReceived ( i );
	    cntDta.Completed[i] = 0;
	}
}
	 

#ifdef WITH_MINSTREL
extern MinstrelData Data;
#endif


static void RequestForm ( char * FormName )
{
    char Id[30];
    CntMsgInitObj ( &cntDta.Send , CntUserName );
    cntDta.Send.TimeStamp = cntDta.timeTick+1;
    CntMsgAddToObj ( &cntDta.Send , CntUserName );
    CntMsgAddToObj ( &cntDta.Send , "|FormRequest|" );
    CntMsgAddToObj ( &cntDta.Send , FormName    );
    CntMsgAddToObj ( &cntDta.Send , ";ID=" );
    StrCopy ( FormNameStash , FormName );
#ifdef WITH_MINSTREL
    StrPrintF ( Id , "%uX%uX%uX%u" , 
		      Data.Spi, Data.Wasi, Data.SPNI, Data.CellID );
#else
    StrPrintF ( Id , "NoneXXX" );
#endif
    CntMsgAddToObj ( &cntDta.Send , Id );
}


static int ClearForm ()
{
   int fldNum  = 0;

   for ( fldNum = 0 ; fldNum < FRM_MAXFIELD ; fldNum++ )
	nForm[fldNum].Class = End;

}

static void SendPair ( char * Field , char * Value )
{
    CntMsgAddToObj ( &cntDta.Send , Field );
    CntMsgAddToObj ( &cntDta.Send , "="   );
    CntMsgAddToObj ( &cntDta.Send , Value );
    CntMsgAddToObj ( &cntDta.Send , "\n"  );
}

static int SendForm ()
{
   int pos;

   CntMsgInitObj   ( &cntDta.Send , CntUserName );
   cntDta.Send.TimeStamp = cntDta.timeTick+1;
   CntMsgAddToObj  ( &cntDta.Send , CntUserName );
   CntMsgAddToObj ( &cntDta.Send , "|FormData|" );

   for ( pos = 0 ; nForm[pos].Class != End; pos++ )
     switch ( nForm[pos].Class )
     {
      case  List:
      case  TrueFalse:
      case  Field:
	SendPair ( nForm[pos].ID , nForm[pos].Data.Text );
     }
}

static void CollectForm ( FormPtr frmP )
{
  FontID fnt;
  int    pos = 0;
  int    x = 5 , y = 5;


   
  for ( pos = 0 ; nForm[pos].Class != End; pos++ )
    switch ( nForm[pos].Class ) 
      {
      case Field:
	{
	  Handle newHand;
	  CharPtr  newPtr;
	  FieldPtr fld;

	  fld   = (FieldPtr) FrmGetObjectPtr (frmP, 
					      FrmGetObjectIndex (frmP, 100+pos));
	  StrCopy ( nForm[pos].Data.Text ,  FldGetTextPtr (fld));
	}
	break;

      case List:
	{
	  ListPtr lst;

	  lst   = (ListPtr) FrmGetObjectPtr (frmP, 
					     FrmGetObjectIndex (frmP, 100+pos));

          if ( !StrCompare ( nForm[pos].ID , "Location"))
	      StrCopy ( nForm[pos].Data.Text , CityLst[LstGetSelection ( lst )]);
          if(!StrCompare ( nForm[pos].ID , "Cuisine"))
	      StrCopy ( nForm[pos].Data.Text , CuisLst[LstGetSelection ( lst )]);
	  if(!StrCompare ( nForm[pos].ID , "NumOfPeople"))
	      StrCopy ( nForm[pos].Data.Text , PeopleLst[LstGetSelection ( lst )]);
	}

	break;

      case TrueFalse:
        {
	  ControlPtr
  	    ctl   = (ControlPtr) FrmGetObjectPtr (frmP, 
						  FrmGetObjectIndex (frmP, 100+pos));
	  if ( CtlGetValue  ( ctl ))
	    StrCopy ( nForm[pos].Data.Text, "True" );
	  else
	    StrCopy ( nForm[pos].Data.Text, "False" );
	
	}
	break;
      }

}



static void BuildForm ( FormPtr frmP )
{
  FontID fnt;
  int    pos = 0;
  int    x = 5 , y = 5;

  CALL_PROLOGUE

    fnt = FntGetFont ();

   
  for ( pos = 0 ; nForm[pos].Class != End; pos++ )
    switch ( nForm[pos].Class )
      {
      case Label:
	FrmNewLabel ( (VoidPtr)&frmP , 100+pos  , nForm[pos].Data.Text , x , y, fnt );
	x += 60;
	break;
      case Field:
	{
	  Handle newHand;
	  CharPtr  newPtr;
	  FieldPtr fld;

	  fld = FldNewField ( (VoidPtr)&frmP , 100+pos  , x , y , 70  , 12 , fnt  ,
			      140 , true , true , true , true , leftAlign ,
			      true , false , false );
	}
	y += 15;
	x  =  5;
	break;
      case List:
	{
	  ListPtr     lst;
	  ControlPtr  ctl;

	  // NetDebug ( "Making a List" , "Lst" );


	  CtlNewControl ( (VoidPtr)&frmP , 200+pos , popupTriggerCtl , NULL ,
			  x , y  , 70 , 12 , fnt , 0 , true );
	  ctl = (ControlPtr) FrmGetObjectPtr (frmP, 
					      FrmGetObjectIndex (frmP, 200+pos));
	  LstNewList ( (VoidPtr)&frmP , 100+pos , x , y , 70 , 22 , fnt , 
		       7 , 200+pos );




	}
	y +=15;
	x  = 5;
	break;
      case TrueFalse:
	{
	  Handle newHand;
	  CharPtr newPtr;
	  ControlPtr ctl;

	  ctl = CtlNewControl ( (VoidPtr)&frmP , 100+pos , checkboxCtl , NULL , 
				x , y , 70 , 12 , fnt , 0 , false );

          y += 15;
          x  =  5;
	}
	break;
      case NewLine:
	y += 15;
	x =  5;
	break;
      }



  for ( pos = 0 ; nForm[pos].Class != End; pos++ )
    switch ( nForm[pos].Class )
      {
      case Field:
	{
	  VoidHand newHand;
	  CharPtr  newPtr;
	  FieldPtr fld;

	  fld   = (FieldPtr) FrmGetObjectPtr (frmP, 
					      FrmGetObjectIndex (frmP, 100+pos));
	  newHand = MemHandleNew (160);
	  newPtr = MemHandleLock (newHand);
	  StrCopy  ( newPtr , nForm[pos].Data.Text );
	  MemHandleUnlock ( newHand );
	  FldSetText ( fld  , newHand , 0 , 140 );
	}
	break;
      case TrueFalse:
	{
	  ControlPtr ctl;

	  ctl = (ControlPtr) FrmGetObjectPtr (frmP, 
					      FrmGetObjectIndex (frmP, 100+pos));

	  if ( !StrCompare (  "True" , nForm[pos].Data.Text ))
	    CtlSetValue ( ctl , 1 ); else CtlSetValue ( ctl , 0 );

	}
	break;
      case List:
        {
	  ListPtr lst;
	  VoidHand hh;

	  lst = (ListPtr) FrmGetObjectPtr ( frmP , 
					    FrmGetObjectIndex (frmP, 100+pos));
	
/*
	  hh = SysFormPointerArrayToStrings ( "One\0" "Two\0" "Three\0" "Four\0",
					      4 );
*/

	   
					 
        if ( !StrCompare ( nForm[pos].ID , "Location"))
	  LstSetListChoices ( lst , CityLst , 11 );
        if ( !StrCompare ( nForm[pos].ID , "Cuisine"))
       	  LstSetListChoices ( lst , CuisLst , 7 );
        if ( !StrCompare ( nForm[pos].ID , "NumOfPeople"))
       	  LstSetListChoices ( lst , PeopleLst , 3 );

	  LstSetHeight ( lst , 7 );
	  LstSetSelection ( lst , 0 );

	   

	}
      }
   
  CALL_EPILOGUE

    }

static void Communicate ()
{
    int actCode;

	    CheckForMail ();
	    switch ( actCode = CntXFerAction () )
	      {
	      case cntActNone:
		break;
	      case cntActSetName:
		 {
		  char Uname[40];
		  StrPrintF ( Uname , "Palm-%d" , SysRandom (0));
		  CntSetUserName ( Uname );
		  ObjAccept ( Uname );
  		  RequestForm ("a1");
		 }
		break;

	      }
}


static Boolean ReplyFormHandleEvent ( EventPtr eventP )
{


  Boolean handled;
  FormPtr frmP;

  CALL_PROLOGUE 

    handled = false;

  switch (eventP->eType) 
    {

    case frmOpenEvent:
      frmP = FrmGetActiveForm();
      BuildForm   ( frmP );
      FrmDrawForm ( frmP);
      handled = true;
      break;

    case ctlSelectEvent:
      frmP = FrmGetActiveForm();
      switch ( eventP->data.ctlSelect.controlID )
	{
	case ReplyBack:
          ClearForm ();
	  RequestForm ( "a1" );
	  FrmGotoForm ( WorkingForm );
	  break;

    	default:
    	  break;
	}	
     case nilEvent:
	  UIBlink (150,180);
	  Communicate ();
	  // UpdateDbgWnd ();
	  break;
    }
	

  CALL_EPILOGUE;
  return handled;

}
static Boolean BadSignalFormHandleEvent ( EventPtr eventP )
{
  Boolean handled = false;
  FormPtr frmP;
  static int bb;
  CALL_PROLOGUE 

    switch (eventP->eType) 
    {

    case frmOpenEvent:
      frmP = FrmGetActiveForm();
      FrmDrawForm ( frmP);
      // DbgWinInit ();
      bb = 0;
      handled = true;
      break;

     case nilEvent:
	  UIBlink (5,10);
	  bb++;
	  if ( bb > 10 ) FrmGotoForm ( WorkingForm );
	  handled = true;
	  break;
  }

  CALL_EPILOGUE;
  return handled;
}

static Boolean WorkingFormHandleEvent ( EventPtr eventP )
{
  Boolean handled = false;
  FormPtr frmP;
  static int bb;

  CALL_PROLOGUE 

    switch (eventP->eType) 
    {

    case frmOpenEvent:
      frmP = FrmGetActiveForm();
      FrmDrawForm ( frmP);
      // DbgWinInit ();
      handled = true;
      break;

     case nilEvent:
	  UIBlink (5,10);
	  bb++;
	  // PRINTF ( "Hello There %d" , bb++ );
	
	  {
	    int actCode;
	    char Num[43];

 
	    VoidHand mm = DmGetResource ( bitmapRsc , 
			TowerAnimation + (bb%4) +
			( (cntDta.badQuality > 0)  ? 10 : 0)  );

	    if ( cntDta.badQuality > 0 ) cntDta.badQuality --;
	    if ( mm != NULL ) 
	      {
		BitmapPtr bmpPtr;
		bmpPtr = MemHandleLock ( mm );
		WinDrawBitmap ( bmpPtr , 10 , 15 );
		MemHandleUnlock ( mm );
		DmReleaseResource ( mm );
	      }


          /// Visualize

          // Visualize Server TTL
 #ifdef WITH_MINSTREL
           {
             int CDPDStat , RRMStat;
             CDPDStat = Data.CDPDStatus;
               StrPrintF ( Num , "Sr: %3d  Ss: %3d CD: %d RRM: %d" , 
                                  ServerTTL , cntDta.SessTTL ,
                                  (int)Data.CDPDStatus , (int)Data.RRMState ); 
               WinDrawChars ( Num , StrLen (Num) , 5 , 60 );
           }
               // Visualize Session TTL
 #endif




	     Communicate ();


	   }
    }


  CALL_EPILOGUE;
  return handled;
}

static Boolean MainFormHandleEvent(EventPtr eventP)
{
  Boolean handled;
  FormPtr frmP;
  static int bb;
    int pos;



  CALL_PROLOGUE 

    handled = false;

  switch (eventP->eType) 
    {

    case frmOpenEvent:
      frmP = FrmGetActiveForm();
      BuildForm ( frmP );
      FrmDrawForm ( frmP);
      //DbgWinInit ();


      handled = true;
      break;

    case ctlSelectEvent:
      frmP = FrmGetActiveForm();
      switch ( eventP->data.ctlSelect.controlID )
	{
	case MainSend:
	  CollectForm ( frmP );
	  SendForm ();
          ClearForm ();
	  FrmGotoForm ( WorkingForm );
	  break;

    	default:
    	  break;
	}	
     case nilEvent:
	  UIBlink (150,180);
	  Communicate ();


	
	  break;
    }
	

  CALL_EPILOGUE;
  return handled;
}



static Boolean ApplicationHandleEvent( EventPtr eventP)
{
  Word formId;
  FormPtr frmP;


  if (eventP->eType == frmLoadEvent)
    {
      // Load the form resource.
      formId = eventP->data.frmLoad.formID;
      frmP = FrmInitForm(formId);
      FrmSetActiveForm(frmP);

      // Set the event handler for the form.  The handler of the currently
      // active form is called by FrmHandleEvent each time is receives an
      // event.
      switch (formId)
	{
	case WorkingForm:
	  FrmSetEventHandler(frmP, WorkingFormHandleEvent);
	  break;
	case MainForm:
	  FrmSetEventHandler(frmP, MainFormHandleEvent);
	  break;
	case ReplyForm:
	  FrmSetEventHandler(frmP, ReplyFormHandleEvent);
	  break;
	case BadSignalForm:
	  FrmSetEventHandler(frmP, BadSignalFormHandleEvent );
	  break;

	default:
	  break;

	}
      return true;
    }
	
  return false;
}


/***********************************************************************/

static Err StartApplication (void)
{
  NetFormPreferenceType prefs;
  Word prefsSize;

  Word	 error;			

  prefsSize = sizeof(prefs);

  PrefGetAppPreferences (NetFormFileCreator, appPrefID,  
			 &prefs, &prefsSize , true);


  CntStart ();
  ClearForm ();
  FrmGotoForm ( WorkingForm );

    
  return 0;
}





static void StopApplication(void)
{
  NetFormPreferenceType prefs;
   

   
  // Write the saved preferences / saved-state information.  This data 
  // will be backed up during a HotSync.
  PrefSetAppPreferences (NetFormFileCreator, 
			 appPrefID, appPrefVersionNum, 
			 &prefs, sizeof (prefs), true);
  CntFinish ();
}



static void EventLoop(void)
{
    EventType event;
    Word      error;

    do
    {
	int timeout = 9;
	// if ( cntDta.State != Idle ) timeout = 25; else timeout = 100;

        EvtGetEvent(&event, timeout);
        if (SysHandleEvent(&event))
            continue;

        if (ApplicationHandleEvent(&event))
            continue;
        FrmDispatchEvent(&event);
    }
    while (event.eType != appStopEvent);
  
}



DWord PilotMain(Word cmd, Ptr cmdBPB, Word launchFlags)
{
    if (cmd == sysAppLaunchCmdNormalLaunch)
    {
//	 _gdb_hook ();
        StartApplication();
        EventLoop();
	StopApplication ();
        return(0);
    }
    return(0);
}

