/*************************************************************
   CntXFerSH		---  Message Exchange Protocol

**************************************************************/

#ifndef __LINUX__
#include <Pilot.h>
#include <StringMgr.h>
#else
#include  <Str.h>
#endif


long SessionsAttempted = 0;
long DataPacketsRecv   = 0;
long DataPacketsSent   = 0;

#include <CntXFer.h>
#include <DebugWnd.h>


#define GoState(s)   {cntDta.shState = s; break; }
#define IfRcvd(s)	 if ( 0 == StrNCompare ( Data , s , StrLen(s)))
#define StDone(s)    (s==shWait)||(s== shCmdSent)||(s==shCmdBusy)||(s == shSendCmd) || \
		     (s==shPkSent)||(s==shRecv)||(s==shXmitBusy)||(s == shProcSent)

#define Abort        {cntDta.shState  = shWait; cntDta.subState = cmAbort;}


#ifdef __LINUX__
/// The following function is for comaptibility only
/// TODO: Thing about cleaner way of handling this
int StrIToA ( char * a , long n  ) { sprintf ( a , "%ld" , n ); }
#endif

int ShSendCmd     ( char * Cmd , char * Arg  )
{
   /* UGLY AND UNOPTIMAL CODE SHOULD BE REPLACED */

    StrCopy ( SessPktData , Cmd );
    StrCat  ( SessPktData , " " );
    StrCat  ( SessPktData , Arg );


    SpPreparePacket ( SessPktData , StrLen ( SessPktData ) + 1 );
   
    cntDta.shState     = shSendCmd;
    cntDta.subState    = cmSend;
    cntDta.pktCTS      = 0;
   
}

int ShSendProceed ( )
{
   StrCopy   ( SessPktData , CNT_PROC );
   MemCopy  ( SessPktData+4, cntDta.Rcv[cntDta.CurrentSession].recvmap , 8 );  

   SpPreparePacket ( SessPktData , 4+8 );
   
   cntDta.shState     = shProcSent;
   cntDta.subState    = cmSend;
   cntDta.pktCTS      = 0;
}


int ShSendPkt     (  )
{
    int n = CntMsgNxtChnk ( &cntDta.Send );

    if ( n == -1 ) return 0;

    StrCopy  ( SessPktData   , CNT_PK );
    MemCopy  ( SessPktData+2 , (char*)&cntDta.Send.Packets[n] , sizeof (CntMsgPkt));

    SpPreparePacket ( SessPktData , 2+sizeof(CntMsgPkt));
    
    cntDta.shState     = shProcSent;
    cntDta.subState    = cmSend;
    cntDta.pktCTS      = 0;

    CntMsgMarkPkt ( &cntDta.Send ,  n );

    DataPacketsSent++;

    return -1;
}

/*
  Function	:	ShNextToken
  Purpose	: 	Seraches for next token and returns it 
			starting position 
*/
int ShNextToken ( char * Str )
{
   int c = 0;
   int st = 1;

  while ( Str[c] )
  {
    switch ( st )
    {
      case 1:
	/* Skip all nonspace */
	if ( Str[c] == ' ' ) st++;
	break;

      case 2:
	/* Skip all space and  */
	if ( Str[c] != ' ' ) { Str[c-1] = 0; return c; }
	break;
   }
   c++;
  }
  return 0;
}

#ifdef SERVER
#define SH_RUSER  cntDta.Devices[cntDta.DeviceIdxs[cntDta.NxtDev]].UserName
#else
#define SH_RUSER  "Server"
#endif

/*
TODO: 
    Upon reception of HELO or HELORESP this layer must go to
    shWait or shConnctd states or more likely 
    

    When sending rejection specify which object we are going to reject
    
    When recieving ACK or REJECTION check what object was rejected or
    acknowlegded. If we don't do these two things then we might run
    into trouble of discaring wrong kind of object due to lagging UDP
    trafic. 

    The two above things should apply to all the commands that affect 
    state of the objects, such as PK

    Maybe all commands have to be numbered, so when we abort, we can tell
    other end that we have aborted, so other end will drop will react only
    if it waits for result of a certain frame....  actually this needs to
    be rethought.


*/

int ShXFerAction ( char * Data , int len  )
{
  int bDone = 0;
  cntDta.cmTimeout = 100;

 /* Check if what we just recieved is indeed a packet and not some
    kind of hallucination
  */
 

 if ( Data[0] == 'Q' )
 {
	/* Looks like protected packet, so check the session
	   number */
      Data += 2 ; len -= 2;
 }


 while ( !bDone )
 { 
 PRINTF1 ("XFer action %d %d " , cntDta.shState , StDone (cntDta.shState));
 switch ( cntDta.shState )
    {
    case shStart:
      /* Check for HELO or HELO_RESP  */     
      PRINTF1  ( "Sh: Starting %s " , Data );
      IfRcvd(CNT_HELO)      GoState(shWait)
      IfRcvd(CNT_HELORESP)  GoState(shConnctd)
      Abort
      break;

    case  shWait :
      PRINTF1 ( "Sh: Waiting : %s " , Data );

      IfRcvd(CNT_NOPE)     GoState(shNopeRcvd)
      IfRcvd(CNT_PROC)     GoState(shProcRcvd)
      IfRcvd(CNT_POLL)     GoState(shPollRcvd)
      IfRcvd(CNT_ACK)      GoState(shAckRej)
      IfRcvd(CNT_REJ)      GoState(shAckRej)
      IfRcvd(CNT_OBJ)      GoState(shObjRcvd)
      Abort
      break;
      
    case  shSendCmd : 
      IfRcvd(CNT_SENT)	   GoState(shWait)
      break;
      
    case  shCmdSent : 
      IfRcvd(CNT_SENT)	   GoState(shWait)
      break;
      
    case  shCmdBusy : 
      break;
      
    case  shAckRej : 
      cntDta.Send.Id[0] = 0;
      cntDta.inProgress = 0;
#ifdef SERVER
      Abort
#else
	// TODO: Find out why this was necessary
	// ShSendCmd ( "Nope" , "" );
      Abort
#endif
      break;
      
    case  shObjRcvd :
      {
        char *ObjName;
	char *sObjTime;
 	char *sObjSize;
        int  ObjSize;
 	long  ObjTime;
        int  bReject = 0;
        int c = 0;

	int objIdx;


	SessionsAttempted++;
	
	c = ShNextToken ( Data );
	if ( c != 0 ) ObjName = Data+c; else Abort

	c = ShNextToken ( ObjName );
	if ( c != 0 ) sObjTime = ObjName+c; else Abort;

        c = ShNextToken ( sObjTime);
        if ( c != 0 ) sObjSize = sObjTime+c; else Abort;

	PRINTF1 ( "Object Strings: %s %s" , sObjTime , sObjSize );

	ObjTime = StrAToI ( sObjTime );
        ObjSize = StrAToI ( sObjSize );

	PRINTF1 ( "Object offered: %s %ld Sz: %d" , ObjName , ObjTime , ObjSize );
	
	/* Check if the object is acceptable */
	if ( -1 == (objIdx =  AcceptableObj ( ObjName , ObjTime ))) bReject = -1;
	else PRINTF1 ( "Type Accepted" );

	/* Check the time-stamp */
	if ( bReject || (cntDta.RcvObjTime[objIdx] > ObjTime)) 
	{
  	       bReject = -1;
	}
	else PRINTF1 ( "Time Accepted" );

	PRINTF1 ( "Obj Time l:%d r:%d %d " , cntDta.RcvObjTime[objIdx] , ObjTime , 
		 ((cntDta.RcvObjTime[objIdx]) > ObjTime)
  	        ); 

	/* Check if there is a session for this object */
	if ( !bReject) cntDta.CurrentSession =
			 ObjSessInProgr ( ObjName , SH_RUSER);

	if ( !bReject && -1 != cntDta.CurrentSession  )
 	{
	   PRINTF1 ( "Found old session %d " , cntDta.CurrentSession );
	   /* Check if it is the same session */
	   if ( ObjTime != cntDta.Rcv[cntDta.CurrentSession].TimeStamp )
		/* Kill session if it is not the same session */
	    {
	       PRINTF1 ( "Session restarted" );
	       CntMsgInitObj ( &cntDta.Rcv[cntDta.CurrentSession] , ObjName );
	       cntDta.Rcv[cntDta.CurrentSession].TimeStamp = ObjTime;
	    }
	 }
	 else
	    {
	      /* Create a new session if needed */
	      if (!bReject) PRINTF1("Creating Session" );
	      if (!bReject) ObjNewSess(ObjName, SH_RUSER );
	      if (!bReject) cntDta.CurrentSession = ObjSessInProgr(ObjName,SH_RUSER);

	      if ( !bReject && -1 != cntDta.CurrentSession  )
	          {PRINTF1("Created");;} else  bReject = -1; 

	      if (!bReject) 
	      {
		CntMsgInitObj(&cntDta.Rcv[cntDta.CurrentSession],ObjName);
	        cntDta.Rcv[cntDta.CurrentSession].TimeStamp = ObjTime;
	        cntDta.Rcv[cntDta.CurrentSession].Size      = ObjSize;
	        PRINTF1 ( "Session started" );
	      }
	    }


	 PRINTF1 ("Remote username %s Slot %d" , SH_RUSER , cntDta.NxtDev  );		
		  
	/* Reject the object */
	if ( bReject ) { PRINTF1 ( "Rejecting" ); ShSendCmd ( CNT_REJ , "" ); }
	else    {  PRINTF1 ( "Receiving" ); 
		   cntDta.inProgress = -1;
		   cntDta.SessTTL = SESSION_TTL;
		   ShSendProceed ( cntDta.CurrentSession ); }
 
      }
      break;

    case  shProcRcvd:
      PRINTF1 ( "Proceed recieved" );
	if ( ! cntDta.procExpctd ) 	
	{
	   PRINTF1( "Proceed not expected" );
	   GoState ( shWait);
	   break;
	} else cntDta.procExpctd = 0;
      /* Copy recvmap to the sending object map */
      MemCopy ( cntDta.Send.recvmap , Data+4 , 8 );
      GoState (shXmit)
      break;
      
    case  shXmit : 
      /* Check if we are done */
      PRINTF1 ( "Transmitting ID: %s Size %d" , cntDta.Send.Id , cntDta.Send.Size );
#ifdef DEBUG2
      //hex_dump(cntDta.Send.recvmap, 8 );
#endif

      if ( CntMsgIsDone ( &cntDta.Send )) {  PRINTF1 ( "We done" );
					     cntDta.procExpctd = -1;
					     ShSendCmd ( CNT_DONE , "" ); break; }

      /* Send it and go back to sleep */
      ShSendPkt ();
      GoState(shPkSent)
      break;
      
    case  shXmitBusy: 
      break;
      
    case  shXmitAbort : 
      Abort;
      break;
      
    case  shPkSent : 
      IfRcvd(CNT_SENT)  GoState(shXmit)
      IfRcvd(CNT_ABOR)  GoState(shXmitAbort)
      break;
      
    case  shPollRcvd : 
      PRINTF1 ( "Poll Recieved " );
      /* Update time Sync */
#ifdef SERVER
#else
      {
        int tickOff = ShNextToken ( Data );
        if ( tickOff != 0 ) cntDta.timeTick = StrAToI ( Data+tickOff );
      }
#endif

     if ( cntDta.Send.Id[0] == 0 )
      ShSendCmd ( CNT_NOPE , "" );
     else
      {
	char Str[80];
	char Sanjay[19];
	// Never ever send anything that was created in the future
	if ( cntDta.Send.TimeStamp > cntDta.timeTick )
	  cntDta.Send.TimeStamp = cntDta.timeTick;
	StrIToA ( Sanjay , cntDta.Send.TimeStamp );
	StrPrintF ( Str , "%s %s %d" ,  cntDta.Send.Id , Sanjay ,
		    cntDta.Send.Size  );
        ShSendCmd ( CNT_OBJ  , Str );
	/* Since we sent an object now we can expect proceed */
	cntDta.procExpctd = -1;
      }
      break;

    case  shDisconnect:
      PRINTF1 ( "Disconnect Requested" );
      cntDta.subState = cmAbort;
      cntDta.shState  = shStart;
      break;
      
    case  shDoneRcvd : 
      if ( CntMsgIsDone ( &cntDta.Rcv[cntDta.CurrentSession] )) 
	{  
	  int ObjIdx ;
	  PRINTF2 ( "We done" );
 
	  cntDta.badQuality = 0;
	  ShSendCmd ( CNT_ACK , "" );
	
	  /* From now on we will accept object of timestamp higher then
	     we have now... however we should thing about accepting
	     object with much lower timestamps as well , note that
	     right now AcceptableObj doesn't need second argument.
	     TODO: Change AcceptableObj prototype  */
	  
         if ( -1 != 
	  (ObjIdx = AcceptableObj ( cntDta.Rcv[cntDta.CurrentSession].Id , 0 )))
	{
	 cntDta.RcvObjTime[ObjIdx] = cntDta.Rcv[cntDta.CurrentSession].TimeStamp +1;
	}
	  /* Close session */
	  cntDta.Rcv[cntDta.CurrentSession].Id[0] = 0;
	  /* Notify upstaits */
	  cntDta.Completed[cntDta.CurrentSession] = -1;
	  // CntMessageReceived ( &cntDta.Rcv[cntDta.CurrentSession] );

	  break; 
	}
      
      ShSendProceed ();
      break;
      
    case  shPkRcvd : 
       PRINTF1 ( "Packet rcvd %d " , (int)Data[2] );
      /* Write packet to the msg buffer */
       MemCopy ( (char*)
		 &cntDta.Rcv[cntDta.CurrentSession].Packets[Data[2]], 
		 Data+2 , sizeof(CntMsgPkt));
      /* Mark appropriate buffer */
       CntMsgMarkPkt ( &cntDta.Rcv[cntDta.CurrentSession] , Data[2] );
       DataPacketsRecv++;
       GoState(shRecv);
       break;
      
    case  shProcSent : 
      PRINTF1 ( "Proceed Confirmed" );
      IfRcvd ( CNT_SENT ) GoState (shRecv)
      break;

    case  shRecv : 
      PRINTF1 ( "Receiving" );
      IfRcvd ( CNT_PK )   GoState ( shPkRcvd   )
      IfRcvd ( CNT_DONE ) GoState ( shDoneRcvd )
      IfRcvd ( CNT_ABOR ) GoState ( shRcvAbort )
      break;

    case  shRcvAbort:
      Abort;
      break;

    case  shNopeRcvd: 
#ifdef SERVER
      PRINTF1 ( "Nope recieved" );
      if ( cntDta.Send.Id[0] == 0 ) GoState(shDisconnect)
      else 
	{  
	  char Str[80];
	  StrPrintF ( Str , "%s %d %d" ,  cntDta.Send.Id , cntDta.Send.TimeStamp , 
				       cntDta.Send.Size  );
          cntDta.procExpctd = -1;
	  ShSendCmd ( CNT_OBJ  , Str );
	}
#else
      PRINTF1 ("NOPE on Client?" );
      Abort
#endif
      break;

    case  shConnctd: 
     {
      char TmTick[16];
      /* TODO: BROKEN: Now it doesn't work with new DWORD time, change */
      StrPrintF ( TmTick , "%d" , cntDta.timeTick );
      ShSendCmd ( CNT_POLL , TmTick );
     }
      break;

    default:
	PRINTF1 ( "Unknown state (SH) %d " , cntDta.shState );
    }
   bDone = StDone(cntDta.shState);
  }
}



