/*
   Centaurus Data   -- Sush Protocol Implementation

*/




#ifndef __LINUX__
#include <Pilot.h>
#include <SysEvtMgr.h>
#else
typedef unsigned long ULong;
typedef enum { false = 0, true = -1 } bool;
#include <stdio.h>
#include <Str.h>
#endif


#include <CntXFer.h>
#include <DebugWnd.h>
#include <callback.h>

#ifdef WITH_MINSTREL
#include <Minstrel.h>
#endif

long  recvDgrams = 0;
long  recvBytes  = 0;
long  sentDgrams = 0;
long  sentBytes  = 0;
long  SessionsFailed = 0;


ULong lastRefresh;         /* Time since last refresh */
ULong lastMinstrel;        /* Last time we poked minstrel */
ULong Seconds;
static tagCntUDP CntUDP;
/* Do something about this */

#ifdef WITH_MINSTREL
MinstrelData Data ;
#endif

typedef enum { CNT_STATUS_IND, CNT_DISCOVERY_CNF, CNT_CONN_IND ,     CNT_CONN_CNF ,
	       CNT_DISCON_IND, CNT_DATA_IND     , CNT_PACKET_HANDLED } CntEvents;


#ifndef DISCOVERY_PORT
#error "Discovery Port is Not Defined"
#endif
static int  DiscoveryPort      = DISCOVERY_PORT;

#ifndef SERVER
#ifndef DISCOVERY_ADDR
#error "No Discovery Address Defined"
#endif
static char DiscoveryAddr[128] = DISCOVERY_ADDR;
#else
static char *DiscoveryAddr = "255.255.255.255";
#endif




/* Protocol specific stuff */



/* Canned Messages */

static char *SushUDPRejectClient   = "SUDP.GOAWAY!gentoo";
static char *SushUDPDscFrame       = "SUDP.ANYONEHOME!";
static char *SushUDPIntroduce	   = "SUDP.BEPOLITE";
static char *SushUDPAcptClient	   = "SUDP.WELCOME";
static char *SushUDPBadName        = "SUDP.BADNAME";
static char *SushUDPPing	   = "SUDP.AREYOUTHERE";
static char *SushUDPPong	   = "SUDP.IAMHERE";


#ifdef WITH_MINSTREL
void ReceiveMinstrelData ()
{
  while (MinstrelDataAvailable(&Data))
    {
      Word len;
      static char Dta[128];
      int i;
      
      for ( i = 0 ; i < 120 ; i++ ) Dta[i] = 0;
      len =   MinstrelRecvData  ( &Data , Dta , 120 );
      MinstrelProcessDataPacket ( &Data , Dta );
      lastMinstrel = Seconds;
    }
}
#endif


char * SplitOnBang ( char * Msg )
{
   while ( *Msg != 0 )
	{ if ( *Msg == '!' ) { *Msg = 0; return Msg+1; }
	  Msg++; }

   return NULL;
}

void SpPreparePacket ( char * Buffer , int len )
{
   packet.len  = len;
   packet.buff = Buffer;
   /* If we have protected packet, prepare the thing */
   if ( Buffer == SessPktData )  { 
				   SessTag = 'Q';
				   SessNum = cntDta.SessionNumS; 
				   packet.buff -= 2;
				   packet.len  += 2; }
}

void SpSendBinPacket ( struct sockaddr_in * To , char * Data , int len )
{
    int rv;

    PRINTF2 ( "S>L%d:%s " , len , Data+2 );

    rv =
    sendto ( CntUDP.sk ,
	    Data , len ,
	    0 , (struct sockaddr*)To , sizeof(*To));

    sentDgrams++;
    sentBytes += len;
}

void SpSendStrPacket ( struct sockaddr_in * To , char * Data  )
{
    SpSendBinPacket ( To , Data , strlen(Data)+1);
}

static void InitCntData ()
{
  int i;

  cntDta.State = AskName;

  /* Initialize validation data */
  cntDta.subState = vlNextDevice;
  cntDta.NxtDev = 0;
  cntDta.nDevicesCnt     = 0;
  cntDta.bDevicesValid    = false;
  cntDta.DiscoveryTimeout = 10;
  cntDta.timeTick  = 0;
  cntDta.inProgress = 0;
  cntDta.currentCntxt = -1;
  cntDta.badQuality = 0;

#ifdef SERVER
  for ( i = 0 ; i < MAX_DEVICES ; i ++ )
  {
     cntDta.DeviceIdxs[i] = i;
  }
#endif

  ObjInitObjs  ();

}


int CntStart ( void )
{

 /* Set-up Port */

  int rv;
  int   bcastenabled = 1;

  /* Create a socket that we are going to listen to */

  CntUDP.local_addr.sin_family 		= AF_INET;
  CntUDP.local_addr.sin_port 		= htons(DiscoveryPort);
  CntUDP.local_addr.sin_addr.s_addr 	= htonl(INADDR_ANY);

#ifndef __LINUX__
  PrepareNetwork ();
#ifdef WITH_MINSTREL
  MinstrelInit (&Data); 
#endif
#endif

  CntUDP.sk = socket ( AF_INET , SOCK_DGRAM ,  17 );

  PRINTF3 ( "Got socket %d"  , CntUDP.sk );


#ifdef __LINUX__
  setsockopt ( CntUDP.sk , SOL_SOCKET , SO_BROADCAST , &bcastenabled ,
		sizeof ( bcastenabled ));
#endif

#ifdef SERVER
  rv  = bind (
		CntUDP.sk ,
		(struct sockaddr*)&CntUDP.local_addr ,
		sizeof(CntUDP.local_addr)
	     );
  PRINTF3 ( "Got %d from bind " , rv );
#endif

#ifndef __LINUX__
  rv  = bind (
		CntUDP.sk ,
		(struct sockaddr*)&CntUDP.local_addr ,
		sizeof(CntUDP.local_addr)
	     );

  PRINTF3 ( "Got %d from bind " , rv );
#endif

 	InitCntData ();

 	/* Clean up device table */
 	SpClearDeviceAddrs ();

	/* We don't have a server now */
#ifndef SERVER
	Server.sin_addr.s_addr = 0;
#endif

 return false;

error:
   return true;
}



#ifdef SERVER

int CntDevForUser ( char * UserName )
{
   int i;

   for ( i = 0 ; i < cntDta.nGoodDevices ; i++ )
   {
	if ( !cntDta.Devices[i].Valid ) continue;

	// Look for Username
	if ( !strcmp ( UserName , cntDta.Devices[i].UserName ))
	{
	    // Username found return the thing...
	    return i;
	}
   }

   return -1;
}


int FindDevice ( CntDeviceAddr From   )
{
  int i;
  int avlDevice = -1;


  /** Look for device in the table, and by the way look for availble entry in the table */
  for ( i = 0 ; i < cntDta.nGoodDevices ; i ++ )
  {
   if (
	 cntDta.Devices[i].Valid &&
	 From.sin_addr.s_addr == cntDta.Devices[i].addr.sin_addr.s_addr &&
	 From.sin_port        == cntDta.Devices[i].addr.sin_port  )
   {
	PRINTF2 ( "Old Device %d TTL:%d", i ,  cntDta.Devices[i].TTL );
	return i;
   }
   if (  avlDevice == -1 &&  !cntDta.Devices[i].Valid ) avlDevice = i;
  }

  PRINTF2 ( "Device not found available device is %d " , avlDevice );

  if ( avlDevice != -1  )
  {
     i = avlDevice;
     MemCopy ( (char*)&cntDta.Devices[i].addr ,
	       (char*)&From , sizeof ( cntDta.Devices[i].addr ));
     cntDta.Devices[avlDevice].TTL  =  TTL_START;
     cntDta.Devices[i].UserName[0] = 0;
     cntDta.Devices[i].Good  =
     cntDta.Devices[i].Valid =
     cntDta.Devices[i].New   =  -1;
     return avlDevice;
  }

  /* See if we can grow our device Table */
  if ( cntDta.nGoodDevices < MAX_DEVICES )
  {
     avlDevice = cntDta.nGoodDevices;
     cntDta.nGoodDevices++;
     i = avlDevice;

     MemCopy ( (char*)&cntDta.Devices[i].addr ,
	       (char*)&From , sizeof ( cntDta.Devices[i].addr ));
     cntDta.Devices[i].UserName[0] = 0;
     cntDta.Devices[i].TTL   =  TTL_START;
     cntDta.Devices[i].Good  =
     cntDta.Devices[i].Valid =
     cntDta.Devices[i].New   =  -1;
     return avlDevice;
  }

  return -1;

}



int NewContext ( int i )
{

   CNTXT shState	= shWait	;
   CNTXT subState	= cmStart 	;

   CNTXT pktCTS		= -1		;
   CNTXT CurrentSession	= -1		;

   CNTXT Send.Id[0]     = 0		;

   CNTXT inProgress     = 0		;
   CNTXT SessTTL	= SESSION_TTL		;

   CNTXT SessionNumR    = 0;
   CNTXT SessionNumS    = 0;

   CNTXT procExpctd     = 0;

}


void SwitchContext ( int to )
{
   int i;

   i = cntDta.currentCntxt;

   cntDta.NxtDev = to;

   if ( i != -1 )
  {
   /* Save Cntxt */
   CNTXT inProgress	  = cntDta.inProgress	  ;
   CNTXT SessTTL	  = cntDta.SessTTL	  ;

   CNTXT shState	  = cntDta.shState 	  ;
   CNTXT subState	  = cntDta.subState	  ;

   CNTXT pktCTS		  = cntDta.pktCTS	  ;
   CNTXT CurrentSession	  = cntDta.CurrentSession ;

   CNTXT SessionNumR    = cntDta.SessionNumR;
   CNTXT SessionNumS    = cntDta.SessionNumS;

   CNTXT procExpctd     = cntDta.procExpctd;

   MemCopy ( (char*)&CNTXT Send  ,
	     (char*)&cntDta.Send , sizeof ( cntDta.Send ));

  }

   if ( i == to ) return;

   i = to;
   /* Restore Cntxt */
   cntDta.inProgress	  =  CNTXT inProgress	  ;
   cntDta.SessTTL	  =  CNTXT SessTTL	  ;


   cntDta.shState 	  =  CNTXT shState	 ;
   cntDta.subState	  =  CNTXT subState	 ;

   cntDta.pktCTS	  =  CNTXT pktCTS	 ;
   cntDta.CurrentSession  =  CNTXT CurrentSession;

   cntDta.SessionNumR     =  CNTXT SessionNumR;
   cntDta.SessionNumS     =  CNTXT SessionNumS;
   cntDta.procExpctd      =  CNTXT procExpctd;

   MemCopy ( (char*)&cntDta.Send , (char*)&CNTXT Send , sizeof ( cntDta.Send ));

   cntDta.currentCntxt = i;

}


#endif


/********************
   Static Functions
********************/



/* Initialize Device address table */
void SpClearDeviceAddrs ()
{
   int i;
#ifdef SERVER
   cntDta.bDevicesValid = false;
   for ( i = 0 ; i < MAX_DEVICES ; i++ )
   {
      cntDta.Devices[i].addr.sin_port =
      cntDta.Devices[i].addr.sin_addr.s_addr
				    =
      cntDta.Devices[i].New         =
      cntDta.Devices[i].Valid       =
      cntDta.Devices[i].Good        =  0;
      cntDta.Devices[i].UserName[0] =  0;
   }
#endif
}


//void SpLapDisconnectAction ()
//{
//}



void CntFinish ( void )
{
#ifndef __LINUX__
  Err errno;
  NetLibSocketClose ( AppNetRefnum , CntUDP.sk , 100 , &errno );
  NetLibClose (AppNetRefnum , true ) ;
#endif
}


void CntSetUserName ( char * UserName )
{
   StrCopy(CntUserName,UserName);
}




#ifndef SERVER

CntSendDiscoveryFrame ()
{
  struct hostent * ent;
  struct sockaddr_in  dsc_addr;
  int    rv;

  char Msg[128];

  strcpy ( Msg , SushUDPDscFrame );
  strcat ( Msg , CntUserName );

   /* Prepare discovery address */

#ifndef __LINUX__
  {
    Err errno = 0;
    Long Timeout = 100;
    NetHostInfoBufType  InfoBuf;

#ifdef DEBUG3
    debug_msg ( "Before NetLibGetHost ByName" );
#endif

  if (StrCompare(DiscoveryAddr, "192.168.1.10"))
    ent = NetLibGetHostByName (AppNetRefnum, DiscoveryAddr,
                                &InfoBuf, Timeout, &errno);
    else
    {
 
       dsc_addr.sin_addr.s_addr  = 
		NetLibAddrAToIN ( AppNetRefnum , DiscoveryAddr );
       
    }
    
    PRINTF3 ( "Errno : %d " , errno );
    PRINTF3 ( "DiscoveryAddr %s " , DiscoveryAddr );
  }
#else
if (StrCompare(DiscoveryAddr, "192.168.1.10")) {
  ent = gethostbyname  ( DiscoveryAddr );
  if ( ent == NULL )
    {
      PRINTF2 ( "Don't know about host %s" , DiscoveryAddr );
      return  ;
    }
  MemCopy ( (char*)&dsc_addr.sin_addr.s_addr , ent->h_addr  , 4 );
}
else
  inet_aton ( DiscoveryAddr , &dsc_addr.sin_addr.s_addr );
#endif


  PRINTF1 ( "Will be talking to %s : %d" , DiscoveryAddr, DiscoveryPort );

  dsc_addr.sin_family = AF_INET;
  dsc_addr.sin_port = htons(DiscoveryPort);
  
 {
  static int First = 7;
  if ( First > 4 ) First--; else cntDta.badQuality = 15;
 }

  /* Sent out discovery frame */

   SpSendStrPacket ( &dsc_addr , Msg );
}


#else

void CntSushCheckDeviceTable ()
{
  int i;
  /* Check TTLs */
  for ( i = 0 ; i < cntDta.nGoodDevices ; i ++ )
  {

      if ( ! cntDta.Devices[i].Valid ) continue;
      cntDta.Devices[i].TTL--;

      /* Send out pings to everyone whose TTL is below threshold */
      if ( ( cntDta.Devices[i].TTL < TTL_REVIVE) &&
	   ( 0 == (cntDta.Devices[i].TTL % (TTL_DIVISOR*2) )))
      {
	    PRINTF2 ( "SENDING PING SIGNALZ TO %s" , cntDta.Devices[i].UserName );
	    SpSendStrPacket (  &cntDta.Devices[i].addr , SushUDPPing );
      }

      /* Kill stale devices */
      if ( cntDta.Devices[i].TTL <= 0 ) 
      {
	cntDta.Devices[i].Valid = 0;
	/* If the device is in current context make current context invalid */
	if ( cntDta.currentCntxt == i ) cntDta.currentCntxt = -1;
      }


  }

}
#endif

/*						    
  Pass the processing up to the SH protocol layer.  Monitor the return
  codes and protocol states and restart SH if additional processing is
  required */
int CntSushRunSH ( struct sockaddr_in * addr , char * Msg , int len )
{
 
  int bDone = 0;

  /* Fix up IR legacy */
  if ( cntDta.shState == shStart ) cntDta.shState = shWait;


  /* Deal with hanging sessions and watch for session restarts*/
  // cntDta.SessTTL --;
  if ( cntDta.SessTTL < 0 ||
       (
       !StrNCompare( Msg+2 , CNT_OBJ , StrLen ( CNT_OBJ)) &&
	Msg[0] == 'Q'
       )
				) 
				{ cntDta.shState = shWait; 
				  cntDta.inProgress = 0;
				  cntDta.subState = cmStart;
				  cntDta.SessTTL = SESSION_TTL;  }
			
   
  while ( !bDone )
  {
    cntDta.subState = cmStart;	/* Reset the state first */
    ShXFerAction ( Msg , len );
    
    /* Check the state */
    switch ( cntDta.subState )
    {
	case cmAbort:
		/* Kill the session in progress */
		 cntDta.SessTTL = 0;
	case cmStart:
		/* Either nothing happend or session was aborted
		 * so we just quit 
		 */
		bDone = -1;
		break;
	case cmSend:
		/* Send request was issued, so we'll send it out
		 * and prepare notification for upper level protocol
		 */
		SpSendBinPacket ( addr , packet.buff  , packet.len );
		cntDta.pktCTS = -1;
		Msg = CNT_SENT;
		len = StrLen ( Msg );
		break;
    }
  }

   /* Save current context */
#ifdef SERVER
     SwitchContext ( cntDta.currentCntxt );
#endif
}


int CntSushCheckForData ()
{
  int rv=0;
  int len ;
  static char Msg[256];

#ifdef __LINUX__
  fd_set rfds;
  struct timeval tv;
#else
  NetFDSetType readFDs,writeFDs,exceptFDs;
  Word numFDs;
  Word width;
#endif



  struct sockaddr_in from;




  // Create the descriptor sets
#ifndef __LINUX__
  netFDZero(&readFDs);
  netFDZero(&writeFDs);
  netFDZero(&exceptFDs);
  netFDSet(sysFileDescStdIn, &readFDs);
  netFDSet(CntUDP.sk, &readFDs);
  width = sysFileDescStdIn;
  if (CntUDP.sk > width) width = CntUDP.sk;
#else
  FD_ZERO(&rfds);
  FD_SET(CntUDP.sk, &rfds);
#endif


#ifdef __LINUX__
  /* Set up timeout value for select */
  tv.tv_sec =  0;
  tv.tv_usec = 100000;

  rv = select(CntUDP.sk+1, &rfds, NULL, NULL, &tv);
#else  /*LINUX*/

  
  // Well we need to check every five seconds that we 
  // should have a live connection
 if ( Seconds > lastRefresh+5  )
 {
  Byte allUp = false;
  Word ifErrors = -1;
  Err  errno;
  errno = NetLibConnectionRefresh ( AppNetRefnum , true  ,
				  &allUp , &ifErrors );    
  lastRefresh = Seconds;
 } 

 // If we haven't seen update from the minstrel for more then
 // 10 seconds then it means something is fishy
#ifdef WITH_MINSTREL
 if (  Seconds > lastMinstrel+10 )
   {
     MinstrelAutoRequest ( &Data , 0 , 0 ); 
     ReceiveMinstrelData ();
     //MinstrelResetStats  (&Data);
     MinstrelAutoRequest ( &Data , 1 , 100 ); 
     lastMinstrel = Seconds;
   }
#endif

 // TODO: Reset timer only if we are in the middle of the session
  EvtResetAutoOffTimer ();
  numFDs = NetLibSelect(AppNetRefnum,
			width+1,
			&readFDs, &writeFDs, &exceptFDs,
		        15 , &errno);

 PRINTF3 ( "Select Done %d %d %x E %d" , numFDs ,
				   netFDIsSet ( CntUDP.sk , &readFDs),
                                   readFDs , errno );
   cntDta. SessTTL--;
#endif /*LINUX*/


#ifdef __LINUX__
  if (rv )
#else
  if (netFDIsSet ( CntUDP.sk , &readFDs ))
#endif
  {
#ifdef __LINUX__
     int errno;
     int frmlen = sizeof ( from);
     len = recvfrom ( CntUDP.sk , Msg , 255 , 0 , &from , &frmlen );
#else
     Err errno;
     Word frmlen = sizeof ( from);
#ifdef DEBUG3
     debug_msg ( "Before Recieve" );
#endif DEBUG3
     len =
     NetLibReceive ( AppNetRefnum , CntUDP.sk , Msg , 255 ,  0 , &from ,
                     &frmlen , 100 , &errno );
     PRINTF3 ( "R L:%d Err %d" , len , errno );
     lastRefresh = Seconds;
#endif /*LINUX*/

     recvBytes += len; recvDgrams++; 

     if ( len > 0 )
     {
	int DevIdx;


#ifdef SERVER
	/* See if such device is present, if it is not then check if
	   this message is a cry for a server, if it is not tell the
	   device to introduce itself properly if it is a cry for a
	   server, find device, set appropriate context and let
	   upperlevel protocol do its thing */
	DevIdx = FindDevice ( from );

	PRINTF2 ( "R:%d:%s:%d:%s" , len ,
		inet_ntoa(from.sin_addr), ntohs(from.sin_port),  Msg);


        PRINTF2 ( "Found Devices %d " , DevIdx );
	if ( DevIdx == -1 )
	{
	    /* Can't take anymore devices, sent rejection frame
	       possible enhancement give the address of a new server */

	    SpSendStrPacket (  &from  , SushUDPRejectClient );
	    return 0;
	}
	else
	{
	     cntDta.Devices[DevIdx].TTL =  TTL_START;

	}

	if ( 0 == strcmp ( Msg , SushUDPPong  ))
	{
	    PRINTF2 ( "Got PONG Message " );
	    return 0;
	}

	if ( 0 == StrNCompare ( Msg , SushUDPDscFrame ,  15 ))
	{
	    int i;
  	    char * Nme;
	    PRINTF2 ( "Got New USER %s " , Msg );

	    Nme = SplitOnBang ( Msg );

	    if ( Nme != NULL ) PRINTF2 ( "New User is %s " , Nme );


	    /* Check if it is duplicate name, or we can override it */
	    for ( i = 0 ; i < cntDta.nGoodDevices ; i ++ )
	    {
		if (
 		     0 == strcmp ( Nme , cntDta.Devices[i].UserName ) &&
		     cntDta.Devices[i].Valid			      &&
		    !(
		     cntDta.Devices[i].addr.sin_addr.s_addr == from.sin_addr.s_addr &&
		     cntDta.Devices[i].addr.sin_port  == from.sin_port
		     )
		   )
		{
	    	  SpSendStrPacket (  &from , SushUDPBadName );
		  cntDta.Devices[DevIdx].Valid = 0;
		  return 0;
		}
	    }
	    strcpy (  cntDta.Devices[DevIdx].UserName  , Nme );
	    {
	       /* Add Time to the message */
	       char tmE[20],Snd[50];
#ifdef __LINUX__
	       sprintf(tmE, "%ld", cntDta.timeTick);
#else
	       StrIToA ( tmE , cntDta.timeTick );
#endif
	       StrPrintF ( Snd , "%s!%s" , SushUDPAcptClient , tmE  );
	       SpSendStrPacket (  &from  , Snd );
	    }

	    /* Create a new context for this new device and prepare it's outgoing
	       message thing */
	    NewContext ( DevIdx );
	    return 0;
	}


 	if ( cntDta.Devices[DevIdx].New && cntDta.Devices[DevIdx].UserName[0] == 0  )
	{
		/* This is a new device */
	    	SpSendStrPacket (  &from , SushUDPIntroduce );
		cntDta.Devices[DevIdx].Valid = 0;
		return 0;
 	}



#else
	PRINTF2 ( "R:%d: %s" , len , Msg+2);

        ServerTTL = SESSION_TTL * 4;

	if ( 0 == strcmp ( Msg , SushUDPIntroduce	))
	{
	   PRINTF2 ( "Got introduce message" );
	   CntSendDiscoveryFrame  ();
	   return 0;
	}

	if ( 0 == strcmp ( Msg , SushUDPPong  ))
	{
	    PRINTF2 ( "Got PONG Message " );
	    return 0;
	}

	if ( 0 == StrNCompare ( Msg , SushUDPAcptClient , 12 ))
	{
	  char * tmE;
	   PRINTF2 ( "Got Welcome message" );
	   MemCopy ( (char*)&Server , (char*)&from , sizeof ( Server ));
	   ServerTTL = SESSION_TTL *3;

#ifndef SERVER
	   tmE = SplitOnBang ( Msg );
	   /* TODO : Think about it, the time we got is not the time on the
	             server however. We can assume that everyone got the 
		     same one. And whenever we receive the update of the
		     object we should adjust our time accordingly. And service
		     manager should be the one who keeps the absolute time.. 
		     However, whenever the time rolls over, something must be
		     done with all the things... one good thing to do, is to
		     deliver the time during ping sequences but for now we
		     can keep with whatever we have.....

		     Another thing that we need to do is to watch for server
		     restarts... or change of the servers we are talking to,
		     and if for some reason we have objects in the table or
 		     outgoing queue that are older then server's current
		     time it means that somebody reset the clock on the
		     server, we are talking to different server now... or that
		     we traveled backwards in time. So we need to check 
		     reset the time stamps on all our objects..

		     Note that the above solution will not work if either
		     client or server are traveling at the high speed, which
		     is close to the speed of light. But in this case CDPD
		     will not work anyway...

	   */
	   if ( tmE != NULL ) 
		{
		   long oldTick = cntDta.timeTick;
		   cntDta.timeTick = StrAToI ( tmE );
		   if ( oldTick > cntDta.timeTick )
		    {
		       PRINTF1 ( "Server Reset detected \n" );
		    }
                    else
		    {
		       PRINTF1 ( "Adjusting Outgoing table by %ld" ,
				      cntDta.timeTick - oldTick  );
		       cntDta.Send.TimeStamp +=  cntDta.timeTick - oldTick ;   
		    }
		}
#endif
	   

 	    cntDta.shState	= shWait	;
   	    cntDta.subState	= cmStart 	;
   	    cntDta.pktCTS		= -1	;
   	    cntDta.CurrentSession	= -1	;
   	    cntDta.SessTTL	= -300	;


	   
	   return 0;
	}

	if ( 0 == strcmp ( Msg , SushUDPBadName      ))
	{
	   PRINTF2 ( "Got BAD Name Message" );
	   cntDta.State = AskName;
	   CntUserName[0] = 0;
	   return 0;
	}


	if ( 0 == strcmp ( Msg , SushUDPPing  ))
	{
	   PRINTF2 ( "Got Ping Message" );
   	   SpSendStrPacket ( &from , SushUDPPong );
	   /* If we got the ping it means that all the sessions
	      are dead. */
	   cntDta.SessTTL = -300;
 	   cntDta.inProgress = 0;  

	   return 0;
	}

	if ( 0 == StrNCompare ( Msg , SushUDPRejectClient , 11 ))
	{
	   char * NewSrv;
	   PRINTF2 ( "Got Go Away Message" );
	   NewSrv = SplitOnBang ( Msg );
	   PRINTF2 ( " New server is %s " , NewSrv );
	   if ( NewSrv != NULL ) strcpy ( DiscoveryAddr , NewSrv );
	   CntSendDiscoveryFrame  ();
	   return 0;
	}
#endif

#ifdef SERVER
     SwitchContext ( DevIdx );
#endif
     PRINTF2 ( "UNPROCESSED MESSAGE RECIEVED");
     PRINTF2 ( "M: %s" , Msg[0] == 'Q' ? Msg+2 : Msg );
     CntSushRunSH ( &from , Msg , len );
#ifdef SERVER
     SwitchContext ( DevIdx );
#endif
     return -1; /* Additional packets could be available */
     }

  } else return 0;
}



CntActionResult CntXFerAction ()
{
  int ret;
  CntActionResult actionResult = cntActNone;
  static int pstate = -1;
  int dtaRecv;
  int i;

  /* Update timetick */

  cntDta.timeTick ++;
#ifdef __LINUX__
  Seconds = time(NULL);
#else
  Seconds = TimGetSeconds (); 
#endif

  if ( cntDta.State != pstate )
  {
    PRINTF1 ( "State %d " , cntDta.State );
    pstate = cntDta.State;
  }


#ifdef SERVER
   CntSushCheckDeviceTable ();
#else
   ServerTTL--;
   if ( ServerTTL < 0 ) Server.sin_addr.s_addr = 0;
   if ( ServerTTL < 30 && ServerTTL > 2 ) cntDta.badQuality = 10;
#endif


   if ( cntDta.State == Idle || cntDta.State == Comm )
     {
		while (CntSushCheckForData ());

#ifndef SERVER
#ifdef  WITH_MINSTREL
   //// Well since we are here it means that we should have minstrel
   //// Update thing.... and we can check for the status of CDPD 
   //// and RRM

		// Return if we don't have link established
		if ( Data.RRMState != 4 ) return actionResult;
#endif
#endif
     }


   switch ( cntDta.State )
   {
    case Idle:
#ifdef SERVER
#else
    /* Check if I have a server if there is no server then */
    if ( Server.sin_addr.s_addr == 0 )
    {
      static long srvTimeout = 0;
      if ( srvTimeout > 0 )  { srvTimeout--; break; }

      srvTimeout = TTL_DIVISOR;

      PRINTF1 ( "Ohh, my GOD !!! We don't have a server" );

      CntSendDiscoveryFrame ();
    }
    else
    {
	/* See if we already have a session in progress */
	if ( cntDta.inProgress )
        {
	  PRINTF1 ( "Session TTL %d" , cntDta.SessTTL );
	  cntDta.SessTTL --;
	  if ( cntDta.SessTTL < 0 || cntDta.Send.Id[0] == 0 )
	    {
	      cntDta.inProgress = 0;
	      if ( cntDta.Send.Id[0] != 0 ) 
		{
		  cntDta.badQuality = 10;
		  SessionsFailed++;
		  PRINTF1 ( "SESSION KILLED"  );
		}
	    }
	  if ( cntDta.SessTTL < 5 ) cntDta.badQuality = 10;
	}
	else
	{
	     /* So if we have something to send then kick it off */

	     if (  cntDta.Send.Id[0] ) 	
	     {
	        PRINTF1 ( "We have some data %s " , cntDta.Send.Id );
		cntDta.inProgress = -1;
		cntDta.SessTTL    = SESSION_TTL;
		cntDta.shState    = shWait;

     	        CntSushRunSH ( &Server , CNT_POLL , StrLen ( CNT_POLL)  );
	     }
	}
    } 

#endif

     /* TODO: for the client don't use context things just do the insides of 	
	the loop below */ 

#ifdef SERVER
    /* Save current context */
     SwitchContext ( cntDta.currentCntxt );

    /* Look through the Differnet Contexts and see if there is an object to be
       send, for which we don't have a session in progress 
     */
     for ( i = 0 ; i < cntDta.nGoodDevices ; i++ )
     {
	if ( !cntDta.Devices[i].Valid ) continue;
 	/* TODO: Also session timer has to be reset, everytime we deal with
	   ShXFerAction
 	 */
        if ( CNTXT  inProgress )
	{
           /* For each Session in progress, decrease the TTL timer, if TTL timer has
              expired kill this session
            */
	   SwitchContext ( i );
	   cntDta.SessTTL --;
	   SwitchContext ( i );

           PRINTF1 ( "Dev %d STTL %d\n" ,  i , CNTXT SessTTL );
	
           if ( (CNTXT SessTTL < 0) || (CNTXT Send.Id[0] == 0) )
	   {
		if (CNTXT SessTTL < 0)
			{
			SessionsFailed++;
			PRINTF1 ( "TTL exp: Session KILLED" );
			}
		if (CNTXT Send.Id[0] == 0)
			PRINTF1 ( "Send Id null: Session KILLED" );
		SwitchContext ( i );
		cntDta.inProgress = 0;
		SwitchContext ( i );
	   }
	}
	else
	/* If there is no session in progess, but we have data to 
	   send then we will create a session, send a poll message to 
	   ourselves and Start up a session timer */
	{
	     if ( ! CNTXT Send.Id[0] ) continue;
	     SwitchContext ( i );
	     cntDta. inProgress = -1;  
	     cntDta. SessTTL    = SESSION_TTL;
	     cntDta. shState    = shWait;

	     /* Switch to the new device's context */

     	     CntSushRunSH ( &cntDta.Devices[i].addr , CNT_POLL , StrLen ( CNT_POLL)  );
     	     SwitchContext ( i );
	} 
     }
#endif

    break;

    case  AskName:
	if ( CntUserName[0] == 0)
		actionResult = cntActSetName;
	   else
		{
#ifndef SERVER
      		//  CntSendDiscoveryFrame ();
#endif
		  cntDta.State = Idle;
		}
	break;
    }


    /* Check Name */
    return actionResult;
}


void Nothing () { }
