/*
    Debug window source code
    was extracted from Till Harbaum's IR-Ping.c V0.1 
    ( http://www.ibr.cs.tu-bs.de/~harbaum/pilot/ir_ping.html )

*/


#ifdef __LINUX__
#include <Str.h>
#include "DebugWnd.h" 
#endif

#ifndef __LINUX__
 

#include <Pilot.h>
#include <ctype.h>
#include "DebugWnd.h" 
// #include "IR-TestRsc.h"

#define TEXT_TOP   90
#define TEXT_LINES 5
#define MAX_LINES 80

void update_disp_line(int offset) ;

char text_buffer[MAX_LINES+1][MAX_LEN+1];
int  disp_line, text_height;
WinHandle draw_win;
int  win_dirty;

void init_buffer(void) 
{
  int i;

  disp_line=win_dirty=0;
  text_height=FntLineHeight()*TEXT_LINES;

  /* clear buffer */
  for(i=0;i<MAX_LINES;i++) text_buffer[i][0]=0;
}


void UpdateDbgWnd ()
{
      if(win_dirty) update();
}

void DbgWinInit ()
{
      init_buffer();
      draw_win=WinGetDrawWindow();
      update_disp_line(0);
}

char PrintTmp [255];

void debug_msg(char *msg) {
  RectangleType rect; 
  int i;

  /* scroll buffer up one line */
  for(i=MAX_LINES;i>0;i--)
    MemMove(text_buffer[i], text_buffer[i-1], MAX_LEN+1);

  /* store new line */
  text_buffer[0][0]=(StrLen(msg)>MAX_LEN)?MAX_LEN:StrLen(msg);
  MemMove(&text_buffer[0][1], msg, text_buffer[0][0]);

  if(draw_win==WinGetActiveWindow()) 
  {
    /* scroll text up */
    rect.topLeft.x=0;  rect.topLeft.y=TEXT_TOP+FntLineHeight(); 
    rect.extent.x=160; rect.extent.y=text_height-FntLineHeight();
    WinCopyRectangle(draw_win, draw_win, &rect, 0, TEXT_TOP, scrCopy);
  
    /* clear new text area */
    rect.topLeft.x=0;  rect.topLeft.y=TEXT_TOP+text_height-FntLineHeight(); 
    rect.extent.x=160; rect.extent.y=FntLineHeight();
    WinEraseRectangle(&rect,0);

    /* draw string */
    WinDrawChars(
	&text_buffer[disp_line][1], 
	text_buffer[disp_line][0], 0, 
	TEXT_TOP+text_height-FntLineHeight());
  } 
  else win_dirty=1;

  {
    /* clear new text area */
    rect.topLeft.x=0;  rect.topLeft.y=6; 
    rect.extent.x=160; rect.extent.y=FntLineHeight();
    WinEraseRectangle(&rect,0);
    WinDrawChars(msg,StrLen(msg),0,6);
  }
}

char *arrows[]={"\001","\002","\003","\004"};

void update_disp_line(int offset) {
  FormPtr frm;
  int n;

  n=disp_line+offset;

  if(n<0)  n=0;
  if(n>(MAX_LINES-TEXT_LINES))
    n=MAX_LINES-TEXT_LINES;

  if((n!=disp_line)||(offset==0)) {
    frm = FrmGetActiveForm ();

    if(n==0) {
      //CtlSetLabel(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ScrollDown)), arrows[3]);
      //CtlSetEnabled(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ScrollDown)), false);
    }

    if((n==1)&&(offset>0)) {
      //CtlSetLabel(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ScrollDown)), arrows[1]);
      //CtlSetEnabled(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ScrollDown)), true);
    }

    if(n==(MAX_LINES-TEXT_LINES)) {
      // CtlSetLabel(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ScrollUp)), arrows[2]);
      // CtlSetEnabled(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ScrollUp)), false);
    }

    if((n==(MAX_LINES-TEXT_LINES-1))&&(offset<0)) {
      //CtlSetLabel(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ScrollUp)), arrows[0]);
      //CtlSetEnabled(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ScrollUp)), true);
    }

    disp_line=n;
  }
}

void scroll_up(void) 
{
  RectangleType rect; 
  int i;

  update_disp_line(-1);

  if(draw_win==WinGetActiveWindow()) {
    /* scroll text up */
    rect.topLeft.x=0;  rect.topLeft.y=TEXT_TOP+FntLineHeight(); 
    rect.extent.x=160; rect.extent.y=text_height-FntLineHeight();
    WinCopyRectangle(WinGetActiveWindow(),WinGetActiveWindow(), &rect, 0, TEXT_TOP, scrCopy);
    
    /* clear new text area */
    rect.topLeft.x=0;  rect.topLeft.y=TEXT_TOP+text_height-FntLineHeight(); 
    rect.extent.x=160; rect.extent.y=FntLineHeight();
    WinEraseRectangle(&rect,0);
    
    /* draw string */
    WinDrawChars(
	&text_buffer[disp_line][1], 
	text_buffer[disp_line][0], 0, 
	TEXT_TOP+text_height-FntLineHeight());
  } 
  else win_dirty=1;
}

void scroll_down(void) 
{
  RectangleType rect; 
  int i;

  update_disp_line(+1);

  if(draw_win==WinGetActiveWindow()) {
    /* scroll text down */
    rect.topLeft.x=0;  rect.topLeft.y=TEXT_TOP; 
    rect.extent.x=160; rect.extent.y=text_height-FntLineHeight();
    WinCopyRectangle(WinGetActiveWindow(),WinGetActiveWindow(), &rect, 0, TEXT_TOP+FntLineHeight(), scrCopy);
    
    /* clear new text area */
    rect.topLeft.x=0;  rect.topLeft.y=TEXT_TOP; 
    rect.extent.x=160; rect.extent.y=FntLineHeight();
    WinEraseRectangle(&rect,0);
    
    /* draw string */
    WinDrawChars(&text_buffer[disp_line+TEXT_LINES-1][1], text_buffer[disp_line+TEXT_LINES-1][0], 0, TEXT_TOP);
  } else
    win_dirty=1;
}

void update(void) {
  RectangleType rect; 
  int i;

  if(draw_win==WinGetActiveWindow()) {
    /* clear text area */
    rect.topLeft.x=0;  rect.topLeft.y=TEXT_TOP; 
    rect.extent.x=160; rect.extent.y=text_height;
    WinEraseRectangle(&rect,0);
    
    /* draw text */
    for(i=0;i<TEXT_LINES;i++)
      WinDrawChars(&text_buffer[disp_line+i][1], text_buffer[disp_line+i][0], 0, 
		   TEXT_TOP+text_height-(i+1)*FntLineHeight());

    win_dirty=0;
  }
}

#endif
static char hexdigits[]="0123456789abcdef";
void hex_dump(char *bytes, int len) 
{
  int i,j,k;
  char hexstr[64];

  for(i=0; i<1+len/8; i++) {
    for(j=0;(j<8)&&((8*i+j)<len);j++) {
      hexstr[3*j]   = hexdigits[(bytes[8*i+j]>>4)&0x0f];
      hexstr[3*j+1] = hexdigits[bytes[8*i+j]&0x0f];
      hexstr[3*j+2] = ' ';  
    }    
    hexstr[3*j]=0;
    StrCat(hexstr,"    ");

    for(j=0;(j<8)&&((8*i+j)<len);j++) {

      k=StrLen(hexstr);
      if(bytes[8*i+j]>31)
	hexstr[k]=bytes[8*i+j]; 
      else
	hexstr[k]='.';

      hexstr[k+1]=0;
    }    

    debug_msg(hexstr);
  }
}

