/****************************************************************************
Project:  Agents2GO
Program:  UDP Test
Purpose:  Test UDP functionality
****************************************************************************/


#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>



char Msg[256];
char Hostname[128];



int main (int argc , char ** argv )
{
  int sk;
  struct sockaddr_in local_addr , dest_addr;
  int rv, len;
  struct hostent * ent;
  char buffer[1024];
  int err;

  fd_set rfds;
  struct timeval tv;
  int   bcastenabled = 1;

  /* Check if we have enough arguments */
  if ( argc < 2 ) { puts ( "Not enough arguments" ); exit (2); }


  /* Find out which machine we are running on */
  gethostname ( Hostname , 128 );
  printf ( "Running on : %s\n" , Hostname );

  /* Create a socket that we are going to listen to */
  local_addr.sin_family = AF_INET;
  local_addr.sin_port = htons(9100);
  local_addr.sin_addr.s_addr = htonl ( INADDR_ANY );


  /* Fist try to resolve the address as dot and digits */

  if ( 0 == 
  inet_addr ( argv[1] , &dest_addr.sin_addr.s_addr ))
  dest_addr.sin_addr.s_addr = htons ( dest_addr.sin_addr.s_addr );
  {
  ent = gethostbyname  ( argv[1] );

  if ( ent == NULL )
    {
      printf ( "Don't know about host %s \n" , argv[1] );
      exit ( 1 );
    }

  printf ( "Will be talking to %s\n" , argv[1] );

  memcpy ( &dest_addr.sin_addr.s_addr , ent->h_addr  , 4 );
  }
  dest_addr.sin_family = AF_INET;
  dest_addr.sin_port = htons(9100);

/*
  printf ( "Will be using %s " , inet_ntoa ( dest_addr.sin_addr.s_addr ));
*/
    

  sk = socket ( AF_INET , SOCK_DGRAM ,  17 );
  printf ( "Got socket %d \n" , sk );


  setsockopt ( sk , SOL_SOCKET , SO_BROADCAST , (void*)&bcastenabled , 
		sizeof ( bcastenabled ));

  rv  = bind ( sk , (struct sockaddr*)&local_addr , sizeof(local_addr));  
  printf ( "Got %d from bind \n" , rv );

  for ( ;; )
    {
      FD_ZERO(&rfds);
      FD_SET(sk, &rfds);
      /* Wait up to five seconds. */
   

      tv.tv_sec =  1;
      tv.tv_usec = rand() % 111500;


      rv = select(sk+1, &rfds, NULL, NULL, &tv);



   
      if (rv)
	{
	  len = recv ( sk , Msg , 255 , 0 );
 	  if ( len > 0 )
		 printf ( "Recieve done \nLen %d Msg: %s" , len ,  Msg);
	
	}

   
      sprintf ( Msg , "Host %s Time %d " , Hostname , time(NULL));
      sendto ( sk, Msg , strlen(Msg)+1, 0 , (struct sockaddr*)&dest_addr , sizeof(dest_addr));


    }

}
