/*
   IR-Test   --- simple program for experimenting with IR Communications
		 Portions of code were borrowed from Till Harbaum's IR-Ping.c V0.1 
 		 ( http://www.ibr.cs.tu-bs.de/~harbaum/pilot/ir_ping.html )

   This code is free, but i would like receive a copy of programs based on my code. :-)
*/


#include <Pilot.h>
#include <ctype.h>
#include "callback.h"
#include "IR-TestRsc.h"
#include "DebugWnd.h"
#include <CntXFer.h>


void CntMessageReceived ( int n );



/////////////////////////
// Function Prototypes
/////////////////////////

static void    StartApplication(void);
static Boolean MainFormHandleEvent(EventPtr event);
static Boolean ApplicationHandleEvent(EventPtr event);
static void    EventLoop(void);


//////////////////////////
/// Application Globals //
//////////////////////////


char UserName [40] = "";






/////////////////////////////
/// IR Stuff
////////////////////////////







static void UIShowDiscoveryTimeout  ()
{
#ifdef SERVER
  RectangleType r;
  char Cnt[5];

  StrPrintF ( Cnt , "%2d" , cntDta.DiscoveryTimeout ); 
  RctSetRectangle ( &r , 80 , 0 ,  95 , 7 );
  WinEraseRectangle ( &r , 0 );
  WinDrawChars ( Cnt , StrLen ( Cnt ) , 80 , 0 );
#endif
}

static void UIBlink ( int Start , int End )
{
   static bMainFrmUpd;

      if ( bMainFrmUpd  )
      {
	 bMainFrmUpd = false;
	 WinDrawLine ( Start , 5 , End , 5 );
      } 
      else
      {
 	 bMainFrmUpd = true;
	 WinEraseLine ( Start , 5 , End , 5 );
      }
}

/////////////////////////////
/// Main Form handle event 
/////////////////////////////
static Boolean MainFormHandleEvent(EventPtr event)
{
  int actCode;
  FormPtr frm;
  Boolean handled = false;
  static pState = -1;
  ListPtr  lst;
  int i;
  static frmGood = 0;

  switch (event->eType) 
    {
    case ctlRepeatEvent:
      if(event->data.ctlEnter.controlID == ScrollUp) scroll_down();
      if(event->data.ctlEnter.controlID == ScrollDown) scroll_up();
      handled = true;
      break;

    case keyDownEvent:
      switch ( event->data.keyDown.chr )
      {
	case 0xc:
	   handled = true;
	   scroll_up ();
	   break;
	case 0xb:
	   handled = true;
	   scroll_down ();
	   break;
      }
      break;

    case frmOpenEvent:
      FrmDrawForm(FrmGetActiveForm());
      DbgWinInit ();

      

      debug_msg("Centaurus/Test v1, Centaurus group" );
      PRINTF ( "Compiled %s %s " , __DATE__ , __TIME__ );
    {
      UInt HeapID;
      ULong freeP , maxP ;

      HeapID = MemHeapID ( 0 , 0 );
      MemHeapFreeBytes ( HeapID , &freeP , &maxP );
      PRINTF ( "%3d  : %ldb Free, %ld Lrg " ,  HeapID , freeP , maxP );

    }
      debug_msg("");
      CntStart();

      handled = true;
      break;

    case nilEvent:
      cntDta.timeTick++;
      if ( pState != cntDta.State ) { 
#ifdef DEBUG2
	PRINTF ( "State %d" , cntDta.State ); 
#endif
	pState = cntDta.State; }
      handled = true;
      UIBlink ( 150, 180 );

      ///// Check for new mail

      

      for ( i = 0 ; i < MAX_OBJECTS ; i ++ )
        if ( cntDta.Completed[i] != 0 ) 
 	{
            CntMessageReceived ( i );
	    cntDta.Completed[i] = 0;
	}
	 

 /* TEMP:  Grab whatever is in the textfield and set it to Obj */

 /* Removed

      if ( frmGood )
      {
	frm = FrmGetActiveForm();
	if ( frm != NULL ) 
	  {
	    FieldPtr NameFldPtr = NULL;
	    CharPtr  NameStrPtr = NULL;

	    NameFldPtr = (FieldPtr)  
	      FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, RecvMsg ));
	    if (NameFldPtr != NULL) NameStrPtr = FldGetTextPtr (NameFldPtr);
	    if (NameStrPtr != NULL)
	      {
		if ( StrLen ( NameStrPtr) > 35 ) NameStrPtr[20] = 0;
		CntMsgInitObj ( &cntDta.Send , NameStrPtr );
	      }
	  }
      }
  */


      ///// Process State
      switch ( actCode = CntXFerAction () )
	{
	case cntActNone:
		break;
	case cntActSetName:
	  if ( UserName [0] == 0 ) 
	    FrmPopupForm ( frm_AskName ); 
	  else 
	    CntSetUserName ( UserName );
	    frmGood = -1;
	  break;

	case cntActUpdateDiscovery:
	  UIShowDiscoveryTimeout  ();
	  break;

#ifdef SERVER
	case cntActUpdateDevicelist:
	  frm = FrmGetActiveForm();
	  if ( frm != NULL ) 
	    lst  = (ListPtr) FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, DevList ));
	  
	  if ( lst != NULL ) 
	    {
	      LstSetListChoices ( lst , cntDta.DeviceList , cntDta.nGoodDevices );
	      LstDrawList       ( lst );
	    }
	  break;	  
#endif
		
	default:
	  PRINTF ( "PANIC: Unkown Action %d requested " , actCode );
	  
         }
      

      UpdateDbgWnd ();
      handled = true;
      break;

    }

  return(handled);
}

/////////////////////////
// AskNamehandle event
/////////////////////////
static Boolean AskNameFormHandleEvent(EventPtr event)
{
  FormPtr frmP;
  Boolean handled = false;

  switch (event->eType) 
    {
    case frmOpenEvent:
      FrmDrawForm(FrmGetActiveForm());
      handled = true;
      break;

    case ctlSelectEvent:
      frmP = FrmGetActiveForm();

      switch (  event->data.ctlSelect.controlID ) 
      {
	case nmProceed:
            handled = true;
	    /* Obtain text */
	   {
	      FieldPtr NameFldPtr = NULL;
	      CharPtr  NameStrPtr = NULL;

  	      NameFldPtr = (FieldPtr)  
		FrmGetObjectPtr (frmP, FrmGetObjectIndex (frmP, nmName ));
              if (NameFldPtr != NULL) NameStrPtr = FldGetTextPtr (NameFldPtr);
	      if (NameStrPtr != NULL)
              {
		 if ( StrLen ( NameStrPtr) > 20 ) NameStrPtr[10] = 0;
		 StrCopy ( UserName , NameStrPtr );
	      }
	   }
	   FrmReturnToForm ( 0 );
	   break;
      }
      break;
    case nilEvent:
      handled = true;
      UIBlink ( 15 , 28 );
      break;
    }

  return(handled);
}

/////////////////////////
// ApplicationHandleEvent
/////////////////////////
static Boolean ApplicationHandleEvent(EventPtr event)
{
  FormPtr form;
  Word    formId;
  Boolean handled = false;
  
  if (event->eType == frmLoadEvent) {
    formId = event->data.frmLoad.formID;
    form = FrmInitForm(formId);
    FrmSetActiveForm(form);

    switch (formId) {
    case frm_Main:
      FrmSetEventHandler(form, MainFormHandleEvent);
      break;
    case frm_AskName:
      FrmSetEventHandler(form, AskNameFormHandleEvent );
      break;
    }
    handled = true;
  }

  if (event->eType == appStopEvent) CntFinish ();

  return handled;
}


void CntMessageReceived ( int n )
{
   
 FormPtr frmP;
 VoidHand textH;
 FieldPtr fld = NULL;
 CharPtr  textPtr;

 CntMsgObj * msgObj =  &cntDta.Rcv[n];

#ifdef DEBUG1
 PRINTF ( " CENTAURUS MESSAGE HAS BEEN RECEIVED %d " , n  );
#endif



 frmP = FrmGetActiveForm();
 fld = (FieldPtr) FrmGetObjectPtr (frmP, FrmGetObjectIndex (frmP, RecvMsg ));



 textH = (VoidHand)FldGetTextHandle(fld); 


 if ( textH == NULL ) textH = MemHandleNew ( 1024 );
 if ( textH == NULL ) { debug_msg ( "No Memory" ); return ;  }
 FldSetTextHandle (fld, NULL); 


 
 /* resize the chunk if necessary,*/ 
 if ( 0 != MemHandleResize ( (VoidHand) textH , 1024 )) return ;


 /* lock the chunk, write to it, and then */ 
 textPtr = MemHandleLock ( textH );

 /* TODO: Insert code for copying recieved message to the data area */
 StrPrintF ( textPtr , "Message Received\nObj %s \nTime %d \nSize %d",
	      msgObj->Id , msgObj->TimeStamp, msgObj->Size );

 {
    int l = StrLen ( textPtr );
    char c;  

    while ( (c = CntMsgNextChar ( msgObj )) && l < 700 ) 
		{ *(textPtr + l) = c; l++; } 
 
    *(textPtr+l) = 0;
 }

 MemHandleUnlock ( textH );

	{
		  int i;

		  CntMsgInitObj ( &cntDta.Send , "Hello" );
		  CntMsgAddToObj ( &cntDta.Send , CntUserName );
		  CntMsgAddToObj ( &cntDta.Send , "|\n" );
 		  for ( i = 0 ; i < 10 ; i ++ )
 		  {
			CntMsgAddToObj ( &cntDta.Send , "Hello there.\nI am " );
			CntMsgAddToObj ( &cntDta.Send ,  CntUserName      );
			CntMsgAddToObj ( &cntDta.Send , " :-) \n" );
			cntDta.Send.TimeStamp = msgObj->TimeStamp;
		  }
		  ObjAccept ( "Hello" );
 	}

  


 /* unlock the chunk. If the text is in a */ 
 /* Update the text in the field. */ 
 FldSetTextHandle (fld, (Handle)textH); 
 FldDrawField(fld); 

 return ;

}

/////////////////////////
// Start application
/////////////////////////
static void StartApplication(void)
{
  FrmGotoForm(frm_Main);
}


/////////////////////////
// EventLoop
/////////////////////////

static void EventLoop(void)
{
    EventType event;
    Word      error;

    do
    {
	int timeout = 50;
	// if ( cntDta.State != Idle ) timeout = 25; else timeout = 100;

        EvtGetEvent(&event, timeout);
        if (SysHandleEvent(&event))
            continue;

/* MENU IS DIABLED FOR NOW 
        if (MenuHandleEvent(CurrentMenu, &event, &error))
            continue;
*/
        if (ApplicationHandleEvent(&event))
            continue;
        FrmDispatchEvent(&event);
    }
    while (event.eType != appStopEvent);
}


/////////////////////////
// PilotMain
/////////////////////////

DWord PilotMain(Word cmd, Ptr cmdBPB, Word launchFlags)
{
    if (cmd == sysAppLaunchCmdNormalLaunch)
    {
	// _gdb_hook ();
        StartApplication();
        EventLoop();
        return(0);
    }
    return(0);
}

