#include <Pilot.h>
#include <ctype.h>


#include <Unix/sys_types.h>
#include <Unix/sys_socket.h>
#include <Unix/netdb.h>
#include <Unix/netinet_in.h>

#include "DebugWnd.h"

Long AppNetTimeout;
NetHostInfoBufType      AppHostInfo;
NetServInfoBufType      AppServInfo;
Word                    AppNetRefnum;
Err			h_errno;
Err			errno;

int sk;
struct sockaddr_in local_addr , dest_addr;
char Msg[256] = "Palm Pilot";
static networkOpen = 0;



int ShutDownNetwork ()
{
   if ( ! networkOpen ) return 0;
   close ( sk );
}





/******************************************************************
Function:  	PrepareNetwork
Purpose :	Prepare protocol stack and set-up a connection
		to uplink if needed      
******************************************************************/

int PrepareNetwork ()
{           
  Byte allUp = false;
  Word ifErrors = -1;
  int  Err;

  if ( networkOpen ) return;

  Err = SysLibFind  ("Net.lib", &AppNetRefnum);
            
  if (Err)
    {
      PRINTF ( "No network library" );
      return 0;
    }
    
  NetLibOpen ( AppNetRefnum , &ifErrors );
  Err = NetLibConnectionRefresh ( AppNetRefnum , true  ,
				  &allUp , &ifErrors );    

  if ( Err != 0 )
    {
      PRINTF ( "Connection Refresh Failed"  );
      return 0;
    }

  if ( ifErrors != 0 )
    {
      char Err[10];
      StrPrintF ( Err , "%d" , ifErrors );
      PRINTF ( "Interface Errors detected : %s" , Err  );
      return 0;
    }
  if ( allUp == 0 )
    {
      PRINTF ( "NotAll interfaces are up "  );
      return 0;
    }

 

  networkOpen = -1;
  return -1;
}



