#include <Str.h>
#include <DebugWnd.h>
#include <callback.h>
#include <CntXFer.h>
#include <stdlib.h>
#ifdef __LINUX__
#include <sys/time.h>
#include <unistd.h>
#endif

#define MICRO		0.000001
#define MAX_SIZE	8192
#define MAX_MSGS	1000
#define HELORESP	"ResponseFromServer"
#define TINY            32
#define LARGE           64

/* Platform specific timing crap */
/*
  TIME_VALUE   --- data type of the time value
  RECORD_TIME  --- action to record the current time
  TIME_DIFF    --- output time difference in seconds
*/
#ifdef __LINUX__
 
typedef struct timeval TIME_VALUE;
 
 
#define RECORD_TIME(c) gettimeofday(&c,0);
 
char * TimeDiff (TIME_VALUE *a , TIME_VALUE *b )
{
      static char Tmp[89];
      double d =  (double)(b->tv_sec - a->tv_sec)+
           MICRO*(double)(b->tv_usec - a->tv_usec);
 
      sprintf ( Tmp , "%lf" , d );
      return Tmp;
}

char * StrIToA ( char * x , long m )
{
   sprintf ( x , "%ld" , m );
}
 
#define TIME_DIFF(a,b) TimeDiff(&a,&b);
 
#else
 
typedef ULong TIME_VALUE;
//char * TimeDiff(ULong a, ULong b);
double ticksPerSecond;
char * TimeDiff (ULong a, ULong b)
{
   static char Tmp[80] = "Sucks";
   StrPrintF ( Tmp, "%ld" ,  b - a );
 
   {
        Long TickDiff = b - a;
        double x = longToDouble (TickDiff);
 
        x = mulDouble ( x , ticksPerSecond );
        printDouble ( x , Tmp );
        Tmp[6] = 0;
 
   }
 
 
   return Tmp;                                                              
}
#define RECORD_TIME(c) (c = TimGetTicks());
#define TIME_DIFF(a,b) TimeDiff(a,b);


#endif                                                                         

typedef struct {
  int session_num;
  int req_msg_size;
  int sent_msg_size;
} ClientInfo;

ClientInfo ClientTable[50];
TIME_VALUE Start;
char ClientUserName[40] = "", ServerUserName[6]="SERVER";
char DataName[40];
char ResultsFileName[50]="Results/data";
FILE *f;

extern long  recvDgrams;
extern long  recvBytes;
extern long  sentDgrams;
extern long  sentBytes;
extern long  SessionsFailed;
extern long SessionsAttempted;
extern long DataPacketsRecv;
extern long DataPacketsSent;

long rd=0, rb=0, sd=0, sb=0, dpr=0, dps=0;
long sess_failed=0, sess_att=0;

void ProcessMessage(int objnum, char* CName, char *type, char *buffer)
{
  CntMsgObj * msgObj =  &cntDta.Rcv[objnum];
  char c[3] = {0,0,0};

  printf ( "Got Message Sz %d\n"  , msgObj->Size );

  MemSet(CName,sizeof(ClientUserName),0);
  while ((c[0] = CntMsgNextChar(msgObj)) != '|')
  {
    StrCat(CName, &c);
    if ( c[0] == 0 ) break;
  }

  *type = CntMsgNextChar(msgObj);

  buffer[0] = 0;
  while ((c[0] = CntMsgNextChar(msgObj)) != '|')
  {
    StrCat(buffer, &c);
    if ( c[0] == 0 ) break;
  }

  printf ( "Printf Nm %s Type %c Buff %s\n" , CName , *type , buffer );

}

void CntMessageReceived ( int objnum )
{

   static char DataBuffer[MAX_SIZE], Pad[128];  

  int goodbye_msgnum=0, client_msgnum=0;
  int i, snum, req_msg_size, sent_msg_size;
  static int George = 0;
  char *diff, MsgType, dname[40];
  
  ProcessMessage(objnum, ClientUserName, &MsgType, DataBuffer);
  snum = CntDevForUser (ClientUserName);

  printf ( "Message Received Type (%c)\n" , MsgType );
  
  switch (MsgType) {
    
  case 'C':
    printf("Control Message Received...Exiting\n");
    exit(0);
    break;
    
  case 'H':
    rd = recvDgrams;
    rb = recvBytes;
    sd = sentDgrams;
    sb = sentBytes;
    dpr = DataPacketsRecv;
    dps = DataPacketsSent;
    sess_failed = SessionsFailed;
    sess_att = SessionsAttempted;
    
    sscanf(DataBuffer, "%d %d %d", &req_msg_size, &sent_msg_size, &client_msgnum);

    printf ( "Hello Received  %d %d %d \n",  req_msg_size, 
    			        sent_msg_size, client_msgnum);
    
    ClientTable[snum].session_num = client_msgnum;
    ClientTable[snum].req_msg_size = req_msg_size;
    ClientTable[snum].sent_msg_size = sent_msg_size;
    
    CntMsgInitObj ( &cntDta.Send , "ServerObj" );
    CntMsgAddToObj (  &cntDta.Send , ServerUserName );
    CntMsgAddToObj (  &cntDta.Send , "|P" );
    
    for (i=0; i<req_msg_size-25; i++) 
      DataBuffer[i] = (random() & 0x50)+32; 
    
    CntMsgAddToObj ( &cntDta.Send , DataBuffer);
    printf ( "SENDING OBJ SIZE %d\n" , cntDta.Send.Size );
    cntDta.Send.TimeStamp = cntDta.timeTick+1;
    break;
    
  case 'G':
    rd = recvDgrams - rd;
    rb = recvBytes - rb;
    sd = sentDgrams - sd;
    sb = sentBytes - sb;
    dpr = DataPacketsRecv - dpr;
    dps = DataPacketsSent - dps;
    sess_failed = SessionsFailed - sess_failed;
    sess_att = SessionsAttempted - sess_att;
    
    sscanf(DataBuffer, "%d %s", &goodbye_msgnum, DataName);
    printf ( "Goodbye Received %d \n" , goodbye_msgnum );

    sprintf(dname, "%s.%s", ResultsFileName, ClientUserName);
    f = fopen(dname,"a+");

    if (ClientTable[snum].session_num != goodbye_msgnum) 
     { printf("Bad Packet Number on Goodbye Packet\n"); }
    else {
      printf ( "Writing Data to the file\n" );
      fprintf(f , "%s_%d(%d,:) = [ ", DataName, 
              ClientTable[snum].sent_msg_size==32?ClientTable[snum].req_msg_size:ClientTable[snum].sent_msg_size,ClientTable[snum].session_num);
      fprintf(f, "%ld %ld %ld %ld %ld %ld %ld %ld %s ] ;\n", rd, rb, sd,
                sb, dpr, dps, sess_failed, sess_att, strchr(DataBuffer,'M')+1);
      fclose (f);
    }
    break;
    
  default:
    break;
  }
}
 
int main ()
{
  int i, actCode;
  
  /* Start-Up Centaurus */
  CntStart ();
  
  ObjAccept ( "HelloObj" );
  ObjAccept ( "ByeObj" );

  
  for ( ;; )
    {
      /* This should go to the nilEvent processing */
      
      for ( i = 0 ; i < MAX_OBJECTS ; i ++ )
	{
	  if ( cntDta.Completed[i] != 0 )
	    {
	      CntMessageReceived ( i );
	      cntDta.Completed [i] = 0;
	    }
	}

      switch ( actCode = CntXFerAction () )
	{
	case cntActNone:
	  break;
	case cntActSetName:
	  CntSetUserName ( ServerUserName );
	  break;
	  
	case cntActUpdateDiscovery:
	  // printf ( "Discovery Timeout is in %d \n" , cntDta.DiscoveryTimeout );
	  break;
	  
	case cntActUpdateDevicelist:
	  puts ( "Active Devices :" );
	  
	  for ( i = 0 ; i < cntDta.nGoodDevices ; i ++ )
	    {
	      printf ( "   Device :  %s \n" , cntDta.DeviceList[i] );
	    }
	  
	  break;	  
	  
	default:
	  PRINTF ( "PANIC: Unkown Action %d requested " , actCode );
	  
	}
    }
}
