#include <stdio.h>
#include <stdio.h>
#include "XmlParse.h"
#include "CentMsg.h"

#ifdef PALM_PILOT
  #define strcpy StrCopy
#else
  #define StrAToI atoi
#endif

#define XML_NAMES_NEEDED

#include "CentParseMachine.h"

int  tagLevel = 0;

void PrintLvlSpace ()
{
   int i;
   for ( i = 0 ; i < tagLevel*3 ; i++ ) { putchar(' '); }
}

#ifndef PALM_PILOT
void PrintAttrs ( int Tag , TagAttr * attr )
{
  int i;  

  PrintLvlSpace();
  printf (  "Tag %s\n" , TgNames[Tag] );
  for ( i = 0 ; attr->Index[i] != -1 ; i ++ ) 
    {
      PrintLvlSpace();
      printf ( " %s   %s\n" , AttrNames[attr->Encoded[attr->Index[i]]] , 
			      &attr->Encoded[attr->Index[i]+1]);
      
    }   
}
#endif

xmlParseResult XmlParseCallback ( xmlParseAction  a ,   int Tag , void * arg  )
{

#define GeneralSanity { if ( currentMsg == NULL ) return xmlParseNoSanity; }
#define SystemSanity  { GeneralSanity  if ( Section != SystemSection ) return xmlParseNoSanity; }
#define AIDX(c)  { aIdx = GetAttrIdx(arg,c); if ( aIdx == -1 ) return xmlParseError; }
#define APTR     (&((TagAttr*)arg)-> Encoded[((TagAttr*)arg)->Index[aIdx]+1])
#define SetName(c)  { AIDX ( ATTR_name ) strcpy ( currentMsg->c , &((TagAttr*)arg)-> \
		      Encoded[((TagAttr*)arg)->Index[aIdx]+1]); }

  
  int aIdx;

  static enum { Outside , SystemSection ,  DataSection ,AddOnSection, InfoSection , AttribSection }  
		Section = Outside;

  static CentaurusMessage m001;
	    
  static CentaurusMessage * currentMsg;

  switch ( a )
  {
  case xmlParseDocType:
    printf ( "DocType is %s \n" , arg ); 
    if ( strcmp ( arg , "ccml" )) return xmlParseAbort;
    break;
  case xmlParseTag    :
    tagLevel++;
    // PrintAttrs( Tag , arg);
    switch ( Tag )
      {
      case TG_ccml:
	/* Startup a new message */
	Section = Outside;  
	currentMsg = &m001;
	InitCentMsg ( currentMsg );
	break;
	
      case TG_system:
	GeneralSanity
	Section = SystemSection;
	break;
	
      case TG_data:
	GeneralSanity
	Section = DataSection;
	break;
	
      case TG_addons:
	GeneralSanity
	Section = AddOnSection;
	break;
	
      case TG_info:
	GeneralSanity
	Section = InfoSection;
	break;
	
      case TG_diff:
	SystemSanity
	  currentMsg->full = 0;
	break;
      case TG_full: 
	SystemSanity 
	  currentMsg->full = 1;
	break;
      case TG_command :
	SystemSanity
	  currentMsg->command = 1;
	  break;
      case TG_update :
	SystemSanity
	  currentMsg->command = 0;
	  break;
      case TG_valid :
	SystemSanity
	  currentMsg->valid = 0;
	  break;
      case TG_public: 
	SystemSanity
	  currentMsg->public = 1;
	  break;
      case TG_interactive:
	SystemSanity
	  currentMsg->interactive = 1;
	  break;
      case TG_id :
	SystemSanity
        SetName ( id )
	  break;
      case TG_manager: 
	SystemSanity
	SetName ( manager )
	  break;
      case TG_time :
	SystemSanity
          AIDX(ATTR_value)
	  currentMsg->time = StrAToI ( APTR );
	  break;
      case TG_origin: 
	SystemSanity
	SetName ( origin )
	  break;
      case TG_location: 
	SystemSanity
	SetName ( location )
	  break;
      case TG_parent :
	SystemSanity
	SetName ( parent )
	  break;
      case TG_listening:
	SystemSanity
	  break;
      }
    
    break;
   case xmlParseTagEnd : 
        // printf ( "Closing tag %d\n" , LexWhichTag ( &Tags ));
	tagLevel--;
	switch ( Tag ) 
	{
	case TG_ccml:  
	  /* We done */
	  /* Check the message */
	   // if ( CheckCentMsg ( currentMsg ) ) { currentMsg = NULL; break;}
 	  /* Print the Message */
	  // PrintCentMsg ( currentMsg );
	  /* Act upon the message */
	  /* Next tag must begining of the message */
	  currentMsg = NULL;
	  break;
	case TG_system : 
 	  Section = Outside;
	  break;
	case TG_data: 
 	  Section = Outside;
	  break;
	case TG_addons: 
 	  Section = Outside;
	  break;
	case TG_interfaces: 
 	  Section = Outside;
	  break;
	case TG_info :
 	  Section = Outside;
	  break;
	}
	break;
   case xmlParseCDATA  :
	// printf ( "CData \n" );
	break;
   default:
	printf ( "Action %d \n" , a );
	return xmlParseAbort;
  }


  return xmlParseOk;

}

