#include <stdio.h>
#include <stdio.h>
#include "XmlParse.h"

#define XML_PARSER_TABLES_NEEDED
#include "CentParseMachine.h"


typedef enum 
{ 
  prseNone , 
  prseDocTypeStart , 
  prseDocTypeAcc ,
  prseDocTypeCheck,

  prseTagStart,
  prseTagAcc,
  prseTagFinish,
  prseEmptyTagFinish,

  prseAttrStart,
  prseAttrAcc,
 
  prseValueStart,
  prseValueAcc,

  prseClTagStart,
  prseClTagAcc,
  prseClTagFinish,

  prseCDATA,

} ParseAction ;


int  AttrPos = 0;
int  AttrIdxPos = 0;
int  AttrIdx    [20];
char AttrSpace [256];


typedef struct 
{
  int  State;
  int  * Index;
  char * Encoded;
} Machine;


TagAttr Attributes = { AttrIdx , AttrSpace };

Machine  Tags  = { 0 , tgIndex   ,   tgEncoded };
Machine  Attrs = { 0 , attrIndex , attrEncoded };

int  GetAttrIdx ( TagAttr * attr , int Name )
{
  int i;  

  for ( i = 0 ; attr->Index[i] != -1 ; i ++ ) 
    {
       if (  attr->Encoded[attr->Index[i]] == Name ) return i; 
      
    }   

  return -1;

}


void ClearAttrs ()
{
   Attributes.Index[0] = -1;
   AttrPos    =  0;
   AttrIdxPos =  0;
}






stCond  st0Conds[] = {{match,'<',1},{space,' ',0},{any,' ',0},{0,0,0}}; /* CDATA*/
stCond  st1Conds[] = {{match,'!',2},{match,'?',7},
		      {match,'/',31},{any,' ',19},{0,0,0}};
stCond  st2Conds[] = {{match,'-',3},{match,'D',8},{any,' ',-1},{0,0,0}};
stCond  st3Conds[] = {{match,'-',4},{any,' ',-1},{0,0,0}};

/* Comments */
stCond  st4Conds[] = {{match,'-',5},{any,' ', 4},{0,0,0}};
stCond  st5Conds[] = {{match,'-',6},{any,' ', 4},{0,0,0}};
stCond  st6Conds[] = {{match,'>',0},{any,' ', 4},{0,0,0}};

/* Ignore special */
stCond  st7Conds[] = {{match,'>',0},{any,' ',7},{0,0,0}};


/* Doctype        */
stCond  st8Conds [] = {{match,'O',9},{0,0,0}};
stCond  st9Conds [] = {{match,'C',10},{0,0,0}};
stCond  st10Conds[] = {{match,'T',11},{0,0,0}};
stCond  st11Conds[] = {{match,'Y',12},{0,0,0}};
stCond  st12Conds[] = {{match,'P',13},{0,0,0}};
stCond  st13Conds[] = {{match,'E',14},{0,0,0}};
stCond  st14Conds[] = {{space,' ',14},{any,' ',15},{0,0,0}};

stCond  st15Conds[] = {{any,' ',16},{0,0,0}};
stCond  st16Conds[] = {{space,' ',17},{any,' ',16},{0,0,0}};
stCond  st17Conds[] = {{match,'>',0},{any,' ',18},{0,0,0}};
stCond  st18Conds[] = {{match,'>',0},{any,' ',18},{0,0,0}};

/* Tag */
stCond  st19Conds[] = {{any,' ',20},{0,0,0}};
stCond  st20Conds[] = {{space,' ',21},{match,'>',28},{match,'/',29},
		       {any,' ',20},{0,0,0}};



stCond  st21Conds[] = {{space,' ',21},{match,'>',28},{match,'/',29},
		       {any,' ',22},{0,0,0}};

/* Attribute start */
stCond  st22Conds[] = {{any,' ',23,},{0,0,0}};    /* s */
stCond  st23Conds[] = {{space,' ',24},{match,'=',25},{any,' ',23},{0,0,0}};     /* a */

/* Space after attr */
stCond  st24Conds[] = {{space,' ',24},{match,'=',25},{0,0,0}};    
stCond  st25Conds[] = {{space,' ',25},{match,'"',26},{0,0,0}};    
stCond  st26Conds[] = {{match,'"',21},{any,' ',27}};   

/* Attr value */
stCond  st27Conds[] = {{match,'"',21},{any,' ',27},{0,0,0}};    /* e */

/* End of tag */
stCond  st28Conds[] = {{match,'<',1},{any,' ',0},{0,0,0}};    /* CDATA */


/* End of empty tag */
stCond  st29Conds[] = {{match,'>',30},{any,' ',-1},{0,0,0}};    
stCond  st30Conds[] = {{match,'<',1},{any,' ',0},{0,0,0}};    /* CDATA */


/* Closing tag */
stCond  st31Conds[] = {{any,' ',35},{0,0,0}};
stCond  st32Conds[] = {{match,'>',33},{space,' ',34},{any,' ',32},{0,0,0}};
stCond  st33Conds[] = {{match,'<',1},{space,' ',0},{0,0,0}};  /* CDATA */   
stCond  st34Conds[] = {{space,' ',34},{match,'>',33},{any,' ',-1},{0,0,0}};
stCond  st35Conds[] = {{any,' ',32},{0,0,0}};
		       


State States[] 
  = 
{
   /* Startup */

   st0Conds,prseCDATA,	 /* Waiting for opening tag */
   st1Conds,0,   /* Waiting for eclamation  */
   st2Conds,0,   /* Split onto comment or (entity,element,attribute) */
   st3Conds,0,   /* Next one must be another dash to be valid comment */

   /* Comment mode */
   st4Conds,0,   /* Wait for  first dash  */
   st5Conds,0,   /* Wait for  second dash */
   st6Conds,0,   /* Wait for  close brace */


   /* Igore special */
   st7Conds,0,

   st8Conds,0,
   st9Conds,0,
   st10Conds,0,
   st11Conds,0,
   st12Conds,0,
   st13Conds,0,
   st14Conds,0,
   st15Conds,prseDocTypeStart,
   st16Conds,prseDocTypeAcc, 		
   st17Conds,prseDocTypeCheck,  
   st18Conds,0, 		

   
   st19Conds,prseTagStart,
   st20Conds,prseTagAcc,
   st21Conds,0,
   st22Conds,prseAttrStart,
   st23Conds,prseAttrAcc,

   st24Conds,0,
   st25Conds,0,
   st26Conds,prseValueStart,
   st27Conds,prseValueAcc,
   st28Conds,prseTagFinish,
   st29Conds,0,
   st30Conds,prseEmptyTagFinish,
   st31Conds,0,
   st32Conds,prseClTagAcc,
   st33Conds,prseClTagFinish,
   st34Conds,0,
   st35Conds,prseClTagStart,

};

int LexWhichTag (  Machine * m  )
{
   return  m->Encoded[m->Index[m->State]];
}

int LexReset   ( Machine * m )
{
   m->State = 0;
}

int LexProcess ( Machine * m  , char  ltr  )
{
   unsigned char *sPtr = m->Encoded + m->Index[m->State]+1;

   while ( *sPtr != 0 )
   {
     if ( *sPtr == ltr ) { m->State =  *(sPtr+1); return 0; }
     sPtr += 2;
  }
  return -1;
}



xmlParseResult XmlParseAction ( int a , int inp )
{

   xmlParseResult result = xmlParseOk;

static char DocType[20];
static int  DocTypePos;
//    printf ( "Parse Action %d \n" , a );
  switch ( a )
    {
    case prseCDATA:
      if ( inp != '\n' )
      // printf ( "'%c'" , inp );
      result =  XmlParseCallback ( xmlParseCDATA , 0 , NULL );
      break;
    case prseDocTypeStart :
      DocTypePos=0;
      DocType[DocTypePos++] = inp;
      DocType[DocTypePos  ] = 0;
      break; 
    case prseDocTypeAcc :
      DocType[DocTypePos++] = inp;
      DocType[DocTypePos  ] = 0;
      break; 
    case prseDocTypeCheck : 
      result =  XmlParseCallback ( xmlParseDocType , 0 , DocType  );
      break; 
    case prseClTagStart:
    case prseTagStart:
      // printf ( "%c " , inp );
      if ( a == prseTagStart ) ClearAttrs ( );
      LexReset ( &Tags );
      if ( LexProcess ( &Tags , inp ) == -1 ) return xmlParseError;
      break;
    case prseClTagAcc:
    case prseTagAcc:
      // printf ( "%c " , inp );
      if ( LexProcess ( &Tags , inp ) == -1 ) return xmlParseError;
      break;
    case prseEmptyTagFinish:
      result = XmlParseCallback ( xmlParseTag , LexWhichTag ( &Tags), &Attributes );
      if ( result != xmlParseOk ) break;
      result = XmlParseCallback ( xmlParseTagEnd , LexWhichTag ( &Tags), NULL  );
      break;
    case prseClTagFinish:
      result = XmlParseCallback ( xmlParseTagEnd , LexWhichTag ( &Tags), NULL );
      break;
    case prseTagFinish:
      // printf ( "Got tag %d\n " , LexWhichTag ( &Tags ));
      result = XmlParseCallback ( xmlParseTag , LexWhichTag ( &Tags), &Attributes );
      break;
    case prseAttrStart:
      LexReset ( &Attrs );
      if ( LexProcess ( &Attrs , inp ) == -1 ) return xmlParseError;
      break;
    case prseAttrAcc:
      if ( LexProcess ( &Attrs , inp ) == -1 ) return xmlParseError;
      break;
    case prseValueStart:
      // printf ( "Got attribute %d \n" , LexWhichTag ( &Attrs ));
      Attributes.Index[AttrIdxPos++] = ++AttrPos;
      Attributes.Index[AttrIdxPos  ] = -1;
      Attributes.Encoded[AttrPos++ ] = LexWhichTag ( &Attrs );
      break;
    case prseValueAcc:
      Attributes.Encoded[AttrPos++ ] =  inp;
      Attributes.Encoded[AttrPos]   =  0;
      break;
    default:
      printf ( "Action %d \n" , a );
      return xmlParseError;
   }

   return result;
  
}


int XmlParse ()
{
   int c;
   int result;

   while ( EOF != (c = NextChar ()))
   {
   //       printf  (  "Input %c \n" , c );
      result =  XmlParseChar ( c )  ;
      if ( result != xmlParseOk ) {  return result ; } 
   }

   return xmlParseOk;


}





int main ()
{
   int c;

   if ( XmlParse () != xmlParseOk ) puts ( "There were problems with parsing\n" );
   printf ( "\n" );
   return -1;

}
