#include <stdio.h>
#include "XmlParse.h"

#define MAX_ELM_VAL 40
#define MAX_ELEMENT 40
#define MAX_ATTRIBUTE 100 


typedef enum { CData } AType;

typedef struct
{
  char Name[MAX_ELM_VAL];
  int  type;
  int  required[40];
  int  elements[40];
} AttrEnt;


char  AttrElmName[MAX_ELM_VAL];
char  AttrName   [MAX_ELM_VAL];
char  AttrType   [MAX_ELM_VAL];

AttrEnt AttrData[MAX_ATTRIBUTE];
int freeAttr       = 0;
int currentAttr    = 0;
int currentAttrPos = 0;
int currentAttrElm = 0;
int AttrUnhandled  = 0;


typedef struct
{
  int EntNum;
  int EntPos;
} EntStat;

EntStat InputStack[10];

int  isSP = -1;


typedef enum { prseNone, 
	       prseNewEntity , 
	       prseEntityAccName , 
	       prseEntityAccValue ,
	       prseNewElement ,
	       prseElementAccName ,
	       prseAttListElementNameStart , 
	       prseAttListElementNameAcc ,
	       prseAttListNameStart , 
	       prseAttListNameAcc ,
	       prseAttListTypeStart , 
	       prseAttListTypeAcc ,
	       prseAttListOptStart  , 
	       prseAttListOptAcc  ,
	       prseAttListFinish    , 
	       prseRequired 
} ParseAction;


typedef struct
{
  char  tag;
  int  matches[52];
} tgState;

tgState tgStates[250];

int  tgSIndex [250];

int tgNxState;
int tgS;
int tgElm;
int tgElmC;






char     Elements  [MAX_ELEMENT][MAX_ELM_VAL];
int      freeElm = 0;
int      currentElm = -1;
int      currentElmNamePos = -1;




stCond  st0Conds[] = {{match,'<',1},{space,' ',0},{any,' ',-1},{0,0,0}};
stCond  st1Conds[] = {{match,'!',2},{any,' ',-1},{0,0,0}};
stCond  st2Conds[] = {{match,'-',3},{match,'E',7},{match,'A',29},{any,' ',-1},{0,0,0}};
stCond  st3Conds[] = {{match,'-',4},{any,' ',-1},{0,0,0}};

/* Comments */
stCond  st4Conds[] = {{match,'-',5},{any,' ', 4},{0,0,0}};
stCond  st5Conds[] = {{match,'-',6},{any,' ', 4},{0,0,0}};
stCond  st6Conds[] = {{match,'>',0},{any,' ', 4},{0,0,0}};

/* Entitity */
stCond   st7Conds[] = {{match,'N', 8},{match,'L',28},{any,' ', -1},{0,0,0}};
stCond   st8Conds[] = {{match,'T', 9},{any,' ', -1},{0,0,0}};
stCond   st9Conds[] = {{match,'I',10},{any,' ', -1},{0,0,0}};
stCond  st10Conds[] = {{match,'T',11},{any,' ', -1},{0,0,0}};
stCond  st11Conds[] = {{match,'Y',12},{any,' ', -1},{0,0,0}};

stCond  st12Conds[] = {{space,' ',12},{match,'%',18},{any,' ', -1},{0,0,0}};
stCond  st13Conds[] = {{any,' ',14},{0,0,0}};

stCond  st14Conds[] = {{space,' ',15},{any,' ',14},{0,0,0}};
stCond  st15Conds[] = {{match,'"',16},{space,' ',15},{any,' ',-1},{0,0,0}};
stCond  st16Conds[] = {{match,'"',17},{any,' ',16},{0,0,0}};
stCond  st17Conds[] = {{match,'>', 0},{space,' ',17},{any,' ',-1},{0,0,0}};
stCond  st18Conds[] = {{space,' ',18},{any,' ',13},{0,0,0}};

/* Element  */

stCond  st19Conds[] = {{match,'M',20},{any,' ', -1},{0,0,0}};
stCond  st20Conds[] = {{match,'E',21},{any,' ', -1},{0,0,0}};
stCond  st21Conds[] = {{match,'N',22},{any,' ', -1},{0,0,0}};
stCond  st22Conds[] = {{match,'T',23},{any,' ', -1},{0,0,0}};
stCond  st23Conds[] = {{space,' ',23},{any,' ', 25},{0,0,0}};

stCond  st24Conds[] = {{space,' ',24},{any,' ', 25},{0,0,0}};
stCond  st25Conds[] = {{any,' ', 26},{0,0,0}};
stCond  st26Conds[] = {{space,' ',27},{any,' ',26},{0,0,0}};
stCond  st27Conds[] = {{match,'>',0},{any,' ',27},{0,0,0}};

stCond  st28Conds[] = {{match,'E',19},{any,' ',-1},{0,0,0}};

/* attribute */
stCond  st29Conds[] = {{match,'T',30},{0,0,0}};
stCond  st30Conds[] = {{match,'T',31},{0,0,0}};
stCond  st31Conds[] = {{match,'L',32},{0,0,0}};
stCond  st32Conds[] = {{match,'I',33},{0,0,0}};
stCond  st33Conds[] = {{match,'S',34},{0,0,0}};
stCond  st34Conds[] = {{match,'T',35},{0,0,0}};
stCond  st35Conds[] = {{space,' ',35},{any,' ',36},{0,0,0}};	/* Space after ATTLIST */
stCond  st36Conds[] = {{any  ,' ',37},{0,0,0}};	      		/* First letter of elmnt name */
stCond  st37Conds[] = {{space,' ',38},{any,' ',37},{0,0,0}};  	/* Letters of the elmnt name */
stCond  st38Conds[] = {{space,' ',38},{any,' ',39},{0,0,0}};
stCond  st39Conds[] = {{any  ,' ',40},{0,0,0}};			/* First letter of attr name */
stCond  st40Conds[] = {{space,' ',41},{any,' ',40},{0,0,0}};	/* Letters of the attr name */
stCond  st41Conds[] = {{space,' ',41},{any,' ',42},{0,0,0}};
stCond  st42Conds[] = {{any,' ',43},{0,0,0}};			/* First letter of the type */
stCond  st43Conds[] = {{space,' ',44},{any,' ',43},{0,0,0}}; 	/* Letters of the type */
stCond  st44Conds[] = {{match,'>',0},{match,'#',45},{space,' ',44},{any,' ',39},{0,0,0}};

stCond  st45Conds[] = {{match,'R',46},{0,0,0}};
stCond  st46Conds[] = {{match,'E',47},{0,0,0}};
stCond  st47Conds[] = {{match,'Q',48},{0,0,0}};
stCond  st48Conds[] = {{match,'U',49},{0,0,0}};
stCond  st49Conds[] = {{match,'I',50},{0,0,0}};
stCond  st50Conds[] = {{match,'R',51},{0,0,0}};
stCond  st51Conds[] = {{match,'E',52},{0,0,0}};
stCond  st52Conds[] = {{match,'D',53},{0,0,0}};
stCond  st53Conds[] = {{match,'>',0},{space,' ',44},{0,0,0}};

State States[] 
  = 
{
   /* Startup */

   st0Conds,0,	 /* Waiting for opening tag */
   st1Conds,0,   /* Waiting for eclamation  */
   st2Conds,0,   /* Split onto comment or (entity,element,attribute) */
   st3Conds,0,   /* Next one must be another dash to be valid comment */

   /* Comment mode */
   st4Conds,0,   /* Wait for  first dash  */
   st5Conds,0,   /* Wait for  second dash */
   st6Conds,0,   /* Wait for  close brace */

   /* Wait element mode */

    st7Conds,0,  
    st8Conds,0,
    st9Conds,0,
   st10Conds,0,
   st11Conds,0,
   st12Conds,0,   /* Entity matched */
   st13Conds,prseNewEntity,
   st14Conds,prseEntityAccName,   /* accumulate entity name */
   st15Conds,0,
   st16Conds,prseEntityAccValue,   /* accumulate entity value */
   st17Conds,0, 
   st18Conds,0,

   st19Conds,0,
   st20Conds,0,
   st21Conds,0,
   st22Conds,0,
   st23Conds,0,   /* Element matched */
   st24Conds,0,
   st25Conds,prseNewElement,   		  /* element name begins */
   st26Conds,prseElementAccName,	  /* continue with element name */
   st27Conds,0,   /* Eat the rest of the data model */
   st28Conds,0,

   st29Conds,0,	  /* match  attlist */
   st30Conds,0,	  /* match  attlist */
   st31Conds,0,	  /* match  attlist */
   st32Conds,0,	  /* match  attlist */
   st33Conds,0,	  /* match  attlist */
   st34Conds,0,	  /* match  attlist */
   st35Conds,0,	  /* match  attlist */
   st36Conds,prseAttListElementNameStart,  /* start collecting name */
   st37Conds,prseAttListElementNameAcc,	  /* Ignore  attlist */
   st38Conds,0,	  /* Ignore  attlist */
   st39Conds,prseAttListNameStart,	  /* Ignore  attlist */
   st40Conds,prseAttListNameAcc,	  /* Ignore  attlist */
   st41Conds,0,	  /* Ignore  attlist */
   st42Conds,prseAttListTypeStart,	  /* Ignore  attlist */
   st43Conds,prseAttListTypeAcc,	  /* Ignore  attlist */
   st44Conds,prseAttListFinish,  /* Finsihing the list */

   st45Conds,0,	  /* match  REQUIRED */
   st46Conds,0,	  /* match  REQUIRED */
   st47Conds,0,	  /* match  REQUIRED */
   st48Conds,0,	  /* match  REQUIRED */
   st49Conds,0,	  /* match  REQUIRED */
   st50Conds,0,	  /* match  REQUIRED */
   st51Conds,0,	  /* match  REQUIRED */
   st52Conds,0,	  /* match  REQUIRED */
   st53Conds,prseRequired,  /* matched  REQUIRED */

};

void Error ( char * Str )
{
  puts ( Str );
  return ;
}

AType WhichType ( char * Type )
{
   if ( !strcmp ( Type , "CDATA" )) return CData;

   Error ( "Unknown attribute type" );
}

int FindElement ( char * Name )
{
   int i;

   for ( i = 0 ; i < freeElm ; i ++ )
   {
	if ( !strcmp(Elements[i],Name)) return i;
   }

   return -1;

}

void HandleAttribute ()
{
  int i;
  int bFound = 0;
  int aType  = WhichType ( AttrType );
  /* Try to locate the attribute first */

  for ( i = 0 ; i < freeAttr ; i ++ )
  {
      if ( !strcmp(AttrName,AttrData[i].Name)  &&
	   aType == AttrData[i].type )
	{
	  int lElm ; 
	  
	  currentAttrElm = FindElement(AttrElmName) ;
	  if ( currentAttrElm == -1 ) Error ( "Nonexisiting element in attribute field" );

	  /* Fill in the stuff and then return */
	  // printf ( "\nEXISTING ATTRIBUTE\n" );
	  
	  for ( lElm = 0 ; lElm < 40 ; lElm ++ )
	    {
	      if ( AttrData[i].elements[lElm] == -1 )
		{
		  AttrData[i].elements[lElm] = currentAttrElm  ; 
		  AttrData[i].elements[lElm+1] = -1 ;
		  break;
		}
	      
	    }

	  return;
	  
	}
  }

  /* If it is found, add stuff to elements */
  
  freeAttr++;
  if ( freeAttr >= MAX_ELEMENT ) Error ( "Too many attributes" ); 
  currentAttr = freeAttr-1; 
    
  strcpy ( AttrData[i].Name,AttrName );
  AttrData[i].type = aType;
  AttrData[i].elements[0] = (currentAttrElm = FindElement(AttrElmName));
  AttrData[i].elements[1] = -1;

  if ( currentAttrElm == -1 ) Error ( "Nonexisiting element in attribute field" );
  
  
}


xmlParseResult XmlParseAction ( int a , int inp )
{
   switch ( a )
   {
   case prseRequired:
	break;
   case prseAttListFinish:
     if ( AttrUnhandled ) { 
       HandleAttribute ();
       AttrUnhandled = 0; }
     break;
   case prseAttListTypeStart:
     currentAttrPos = 0;
     AttrType[currentAttrPos++] = inp;
     AttrType[currentAttrPos] = 0;
     break;
   case prseAttListTypeAcc:
     if ( currentAttrPos == -1 ) Error ( "Parse error unexepected attribute type(attr)");
     AttrType[currentAttrPos++] = inp;
     AttrType[currentAttrPos] = 0;
     if ( currentAttrPos >= MAX_ELM_VAL-2 ) Error ( "Type is too long" );
     break;
   case prseAttListElementNameStart:
     currentAttrPos = 0;
     AttrElmName[currentAttrPos++] = inp;
     AttrElmName[currentAttrPos] = 0;
     break;
   case prseAttListElementNameAcc:
     if ( currentAttrPos == -1 ) Error ( "Parse error unexepected element name(attr)");
     AttrElmName[currentAttrPos++] = inp;
     AttrElmName[currentAttrPos] = 0;
     if ( currentAttrPos >= MAX_ELM_VAL-2 ) Error ( "Element name is too long" );
     break;
   case prseAttListNameStart:
     currentAttrPos = 0;
     AttrName[currentAttrPos++] = inp;
     AttrName[currentAttrPos] = 0;
     AttrUnhandled = -1;
     if ( currentAttrPos >= MAX_ELM_VAL-2 ) Error ( "Element name is too long" );
     break;
   case prseAttListNameAcc:
     if ( currentAttrPos == -1 ) Error ( "Parse error unexepected element name(attr)");
     AttrName[currentAttrPos++] = inp;
     AttrName[currentAttrPos] = 0;
     if ( currentAttrPos >= MAX_ELM_VAL-2 ) Error ( "Attribute name is too long" );
     break;
   case prseNewElement :
     freeElm++;
     if ( freeEnt >= MAX_ELEMENT ) Error ( "Too many elments" ); 
     currentElm = freeElm-1; 
     currentElmNamePos = 0; 
     Elements[currentElm][currentElmNamePos++] = inp;
     Elements[currentElm][currentElmNamePos] = 0;
     break;
     
   case prseElementAccName :
     if ( currentElmNamePos == -1 ) Error ( "Parse error unexpected entity name" ); 
     Elements[currentElm][currentElmNamePos++] = inp;
     Elements[currentElm][currentElmNamePos] = 0;
     if ( currentEntNamePos >= MAX_ELM_VAL-2 ) Error ( "Entity name is too long" ); 
     break;
     
   case prseNewEntity:
     freeEnt++;
     if ( freeEnt >= MAX_ENTITY ) Error ( "Too many entities" ); 
     currentEnt = freeEnt-1; 
     currentEntNamePos = 0; 
     Entities[currentEnt].EntName[currentEntNamePos++] = inp;
     Entities[currentEnt].EntName[currentEntNamePos] = 0;
     if ( currentEntNamePos >= MAX_ENT_NAME-2 )  Error ( "Entity name is too long" ); 
     currentEntValPos  = -1;
     break;

   case prseEntityAccName :
     if ( currentEntNamePos == -1 ) Error ( "Parse error unexpected entity name" ); 
     Entities[currentEnt].EntName[currentEntNamePos++] = inp;
     Entities[currentEnt].EntName[currentEntNamePos] = 0;
     if ( currentEntNamePos >= MAX_ENT_NAME-2 ) Error ( "Entity name is too long" ); 
     break;
	
   case  prseEntityAccValue:
     if ( inp == '"' ) 
       {
	 if ( currentEnt < 0 || currentEntValPos != -1 ) Error  ( "Spurious new entity value" );
	 currentEntValPos = 0;
       }
     else
       {
	 if ( currentEnt < 0 || currentEntValPos == -1 ) Error  ( "Spurious new entity value" ); 
	 Entities[currentEnt].EntVal[currentEntValPos++] = inp;
	 Entities[currentEnt].EntVal[currentEntValPos] = 0;
	  if ( currentEntNamePos >= MAX_ENT_VAL-2 ) Error ( "Entity value is too long" ); 
       }
	break;
	
   default :
        Error ( "Bad" ); 
	break;
	
   }
}

int mToc (int c)
{
   if ( c < 26 ) return c+'A';
   else return c+'a'-26;

}



int main ()
{
   int i;
   int c;

   ParseReset ();

   while ( EOF != (c = NextChar ()))
   {
       // printf  (  "Input %c \n" , c );
      if ( XmlParseChar ( c ) == -1 ) {  return -1 ; } 
   }

   for ( i = 0 ; i < freeElm ; i ++ )
	printf  ( "#define TG_%s \t %d \n" , Elements[i] , i + 1  );

   puts ( "\nextern char * TgNames [];\n\n" );

   puts ( "\n\n\n#ifdef XML_NAMES_NEEDED\n" );

   printf ( "\n\n /* Tag Names */ \nchar *TgNames[] = {\"<<nil>>\"," );
   
   for ( i = 0 ; i < freeElm ; i ++ )
	printf  ( " \"%s\" %c\n" , Elements[i] , (i<(freeElm-1)) ? ',' : ' '  ); 

   printf ( "};\n" );

   printf ( "#endif\n" );
 
   /* Init tg states */

   for ( i = 0 ; i < 200 ; i ++ )
   {
      int j;
      tgStates[i].tag = -1;
      for ( j = 0 ; j < 26 ; j ++ ) tgStates[i].matches[j] = 0;
   }
  
   tgNxState	 = 1;  /* Next available state */

   for ( tgElm = 0 ; tgElm < freeElm ; tgElm ++ )
   {
  
      tgElmC 	 = 0;  /* Current Element Col  */
      tgS 	 = 0;  /* Current State        */
      
      while ( -1 )
      {
	  int  c = Elements[tgElm][tgElmC] ;
          int  m = 0;
	  if ( c == 0 )  { tgStates[tgS].tag = tgElm; break; }

	  if ( c >= 'Z' && c >= 'a' && (c <= 'z') ) m = c - 'a' + 26;
	  if ( c >= 'A' && c <= 'Z' ) m = c - 'A' ;


	  if ( tgStates[tgS].matches[m] == 0 )
	  {
	     tgStates[tgS].matches[m] = tgNxState;
	     tgS = tgNxState;
	     tgNxState ++;
	  }
	  else
	  {
	     tgS = tgStates[tgS].matches[m];
	  }
	  
	
          tgElmC++;

      }

   }

   tgElmC = 0;
   /* Print out encoded state machine */


 puts   ( "\n\n\n#ifdef XML_PARSER_TABLES_NEEDED\n\n\n" );

 puts   ( "/* Encoded State machine */\n" );
 printf ( "unsigned char  tgEncoded[] = {  \n" );
   for ( i = 0 ; i < tgNxState ; i ++ )
   {
      int j = 0;


      printf ( "\t/* State %d  %s %d */ \n" , i , tgStates[i].tag == -1 ? "" : Elements[tgStates[i].tag]  , tgElmC  );

      tgSIndex[i] = tgElmC;
      printf ( "\t %d , \n" , tgStates[i].tag + 1 );
      tgElmC++;

      for  ( j = 0 ; j < 52 ; j ++ ) 
	{
	  if ( tgStates[i].matches[j] != 0 )
	      { printf ( "\t    '%c' , %d, \n", mToc(j), tgStates[i].matches[j] ); tgElmC += 2; }
	} 
      
      printf ( "\t 0 , \n" );
      tgElmC++;
      
   }

   printf ( "\t 0 };\n\n" );



   puts ( "/* State Index */" );
   puts ( "int tgIndex[] = { \n" );

   for ( i = 0 ; i < tgNxState ; i++ )
   {
 	printf ( " %d, " , tgSIndex[i] );     

   }

   puts ( "0 };  \n" );


   puts ( "#endif\n\n" );

   for ( i = 0 ; i < freeAttr ; i ++ )
   {

        int j;

	printf  ( "#define ATTR_%s \t %d \n" , AttrData[i].Name , i + 1  );

/*
	for ( j = 0 ;  AttrData[i].elements[j] != -1 ; j++ )
		printf ( " %s" , Elements[AttrData[i].elements[j]] );
	
	printf ( "\n" );
*/
   }

/****************************************************************
		ATTRIBUTE  RECOGINIZER 
*****************************************************************/


 for ( i = 0 ; i < 200 ; i ++ )
   {
      int j;
      tgStates[i].tag = -1;
      for ( j = 0 ; j < 26*2 ; j ++ ) tgStates[i].matches[j] = 0;
   }
  
   tgNxState	 = 1;  /* Next available state */

   for ( tgElm = 0 ; tgElm < freeAttr ; tgElm ++ )
   {
  
      tgElmC 	 = 0;  /* Current Element Col  */
      tgS 	 = 0;  /* Current State        */
      
      while ( -1 )
      {
	  int  c = AttrData[tgElm].Name[tgElmC] ;
          int  m = 0;
	  if ( c == 0 )  { tgStates[tgS].tag = tgElm; break; }

	  if ( c >= 'Z' && c >= 'a' && (c <= 'z') ) m = c - 'a' + 26;
	  if ( c >= 'A' && c <= 'Z' ) m = c - 'A' ;


	  if ( tgStates[tgS].matches[m] == 0 )
	  {
	     tgStates[tgS].matches[m] = tgNxState;
	     tgS = tgNxState;
	     tgNxState ++;
	  }
	  else
	  {
	     tgS = tgStates[tgS].matches[m];
	  }
	  
	
          tgElmC++;

      }

   }

   tgElmC = 0;
   /* Print out encoded state machine */
   puts   ( "\n\n\n#ifdef XML_PARSER_TABLES_NEEDED\n\n\n" );

   puts   ( "/* Encoded State machine */\n" );
   printf ( "unsigned char  attrEncoded[] = {  \n" );
   for ( i = 0 ; i < tgNxState ; i ++ )
     {
       int j = 0;
       
       
       printf ( "\t/* State %d  %s %d */ \n" , i , 
		tgStates[i].tag == -1 ? "" : AttrData[tgStates[i].tag].Name  , tgElmC  );
       
       tgSIndex[i] = tgElmC;
       printf ( "\t %d , \n" , tgStates[i].tag + 1 );
       tgElmC++;
       
       for  ( j = 0 ; j < 52 ; j ++ ) 
	 {
	   if ( tgStates[i].matches[j] != 0 )
	      { printf ( "\t    '%c' , %d, \n", mToc(j), tgStates[i].matches[j] ); tgElmC += 2; }
	 } 
       
       printf ( "\t 0 , \n" );
       tgElmC++;
       
     }
   
   printf ( "\t 0 };\n\n" );
   
   
   puts ( "/* State Index */" );
   puts ( "int attrIndex[] = { \n" );
   
   for ( i = 0 ; i < tgNxState ; i++ )
   {
 	printf ( " %d, " , tgSIndex[i] );     

   }

   printf ( "\t 0 };\n\n" );

   puts ( "#endif\n\n" );

   /*********** PRINT OUT ATTRIBUTE NAMES **********/
   puts ( "\nextern char * AttrNames [];\n\n" );

   puts ( "\n\n\n#ifdef XML_NAMES_NEEDED\n" );

   printf ( "\n\n /* Tag Names */ \nchar *AttrNames[] = {\"<<nil>>\"," );
   
   for ( i = 0 ; i < freeAttr ; i ++ )
	printf  ( " \"%s\" %c\n" , AttrData[i].Name , (i<(freeAttr-1)) ? ',' : ' '  ); 

   printf ( "};\n" );

  puts ( "#endif\n\n" );

   return 0;

}

